/**********************************************************************
* Kuvaus: Pmallin (KOKO) esimerkkilaskelmien pohja 			      *
**********************************************************************/ 

/*
Lasketaan etuuksia ja ansiotulojen veroja       		
henkillle ja puolisolle sek lapsilisi, elatustukea 
asumistukia, pivhoitomaksuja ja toimeentulotukea    
kotitalouksille.

1) Makro "Aloitus": Yhteisi oletuksia makromuuttujina.
   Jos oletukset annetaan tmn ohjelman ulkopuolelta, tt ei ajeta.
2) Makro "Generoi_Muuttujat": Fiktiivisen datan generointi, makromuuttujien johdonmukaisuutta tarkistetaan.
   Jos oletukset annetaan tmn ohjelman ulkopuolelta, tt ei ajeta.
3) Makro KOKO_LASKENTA yksiltason laskentaa varten.
	KOKO_LASKENTA (0) laskee henkillle
	KOKO_LASKENTA (1) laskee puolisolle.
	Puolisot erotetaan suff-makromuuttujan avulla antamalla muuttujille nimet muodossa NIMI ja NIMI_PUOL.
4) Makro KOKO_LASKENTA_KOTIT kotitaloustason laskentaa varten
5) Ajetaan kuusi makroa: Aloitus, TeeMakrot, KOKO_LASKENTA (0), KOKO_LASKENTA (1) ja KOKO_LASKENTA_KOTIT
   ja lasketaan marginaaliveroasteet.
6) Kootaan ja tulostetaan tulokset
*/

/* 1. Esimerkkilaskentaa ohjaavat makromuuttujat */

%MACRO Aloitus;

%LET TYYPPI = ESIM; * Parametrien hakutapa, aina ESIM ;

/* Seuraavia vaiheita ei ajeta jos arvot annetaan tmn koodin ulkopuolelta (&EG = 1) */

%IF &EG NE 1 %THEN %DO;

%LET TULOSNIMI_KOKO = koko_esim_&SYSDATE._1; * Simuloidun tulostiedoston nimi ;
%LET VUOSIKA = 2;		* 1 = Vuosikeskiarvo, 2 = datassa annetun kuukauden lainsdnt ;
%LET VALITUT = _ALL_;	* Tulostaulukossa nytettvt muuttujat ;
%LET EROTIN = 2;		* Tulosteessa kytettv desimaalierotin, 1 = piste tai 2 = pilkku;
%LET DESIMAALIT = 2;	* Tulosteessa kytettv desimaalien mr (0-9);
%LET EXCEL = 1;			* Viednk tulostaulukko automaattisesti Exceliin (1 = Kyll, 0 = Ei) ;

* Inflaatiokorjaus. Euro- tai markkamristen parametrien haun yhteydess suoritettavassa
  deflatoinnissa kytettvn kertoimen voi sytt itse INF-makromuuttujaan
  (HUOM! desimaalit erotettava pisteell .). Esim. jos yksi lainsdntvuoden euro on
  peruvuoden rahassa 95 sentti, syt arvoksi 0.95.
  Simuloinnin tulokset ilmoitetaan aina perusvuoden rahassa.
  Jos puolestaan haluaa kytt automaattista inflaatiokorjausta, on vaihtoehtoja kaksi:
  - Elinkustannusindeksiin (kuluttajahintaindeksi, ind51) perustuva inflaatiokorjaus: INF = KHI
  - Ansiotasoindeksiin (ansio64) perustuva inflaatiokorjaus: INF = ATI ;

%LET INF = 1.00; * Syt lukuarvo, KHI tai ATI;
%LET AVUOSI = 2024; * Perusvuosi inflaatiokorjausta varten ;
%LET PINDEKSI_VUOSI = pindeksi_vuosi; * Kytettv indeksien parametritaulukko ;

* Simuloinnissa kytettvien lakimakrotiedostojen nimet ;

%LET LAKIMAK_TIED_OT = OPINTUKIlakimakrot;
%LET LAKIMAK_TIED_TT = TTURVAlakimakrot;
%LET LAKIMAK_TIED_SV = SAIRVAKlakimakrot;
%LET LAKIMAK_TIED_KT = KOTIHTUKIlakimakrot;
%LET LAKIMAK_TIED_LL = LLISAlakimakrot;
%LET LAKIMAK_TIED_TO = TOIMTUKIlakimakrot;
%LET LAKIMAK_TIED_KE = KANSELlakimakrot;
%LET LAKIMAK_TIED_VE = VEROlakimakrot;
%LET LAKIMAK_TIED_KV = KIVEROlakimakrot;
%LET LAKIMAK_TIED_YA = ASUMTUKIlakimakrot;
%LET LAKIMAK_TIED_EA = ELASUMTUKIlakimakrot;
%LET LAKIMAK_TIED_PH = PHOITOlakimakrot;
%LET LAKIMAK_TIED_EP = EPIDEMlakimakrot;

* Simuloinnissa kytettvien parametritaulukoiden nimet ;

%LET POPINTUKI = popintuki;
%LET PTTURVA = ptturva;
%LET PSAIRVAK = psairvak;
%LET PKOTIHTUKI = pkotihtuki;
%LET PLLISA = pllisa;
%LET PTOIMTUKI = ptoimtuki;
%LET PKANSEL = pkansel;
%LET PVERO = pvero;
%LET PVERO_VARALL = pvero_varall;
%LET PASUMTUKI = pasumtuki;
%LET PASUMTUKI_VUOKRANORMIT = pasumtuki_vuokranormit;
%LET PASUMTUKI_ENIMMMENOT = pasumtuki_enimmmenot;
%LET PELASUMTUKI = pelasumtuki;
%LET PPHOITO = pphoito;
%LET PEPIDEM = pepidem;

%END;

* Ajetaan lakimakrot ja tallennetaan ne;

%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_VE..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_SV..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_TT..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_KT..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_OT..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_KE..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_LL..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_YA..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_EA..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_TO..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_PH..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_EP..sas";

%MEND Aloitus;

%Aloitus;


/* 2. Datan generointia ohjaavat makromuuttujat */

%MACRO Generoi_Muuttujat;

/* Seuraavia vaiheita ei ajeta jos arvot annetaan tmn koodin ulkopuolelta (&EG = 1) */

%IF &EG NE 1 %THEN %DO;

/* 2.0 Lainsdntvuosi ja -kuukausi*/

%LET MINIMI_KOKO_VUOSI = 2024;
%LET MAKSIMI_KOKO_VUOSI = 2024;

%LET MINIMI_KOKO_KUUK = 12;
%LET MAKSIMI_KOKO_KUUK = 12;

/* 2.1 Perhett koskevia tietoja */

/*
PUOLISO = 0 tai 1
LAPSIA_ALLE3: Alle 3-vuotiaiden lasten lukumr
LAPSIA_3_6: 3-6-vuotiaiden lasten lukumr
LAPSIA_7_9: 7-9-vuotiaiden lasten lukumr
LAPSIA_10_15: 10-15-vuotiaiden lasten lukumr
LAPSIA_16: 16-vuotiaiden lasten lukumr
LAPSIA_17: 17-vuotiaiden lasten lukumr

Eri ikryhmiin kuuluvien lasten lukumrt:
 - Alle 3-vuotiaiden ja 3-6-vuotiaden lasten lukumrt tarvitaan
   lasten kotihoidon tuen ja pivhoitomaksujen laskentaan.
 - Alle 10-vuotiaat ja 10 v tyttneet lapset on eriteltv toimeentulotukea varten.
 - 16-vuotiaiden ja 17-vuotiaiden lasten lukumr tarvitaan, jos
   eri jrjestelmien (lapsilist, asumistuki, elkkeensaajien
   lapsikorotus, verotus, tyttmyysturva) ikrajat ja niiden muutokset
   1990-luvulta lhtien halutaan ottaa huomioon.
 - Jos kiinnostus liittyy vain normaalin nykyisen lain 
   lapsilisn riitt esim. muuttuja lapsia_10_15.
 - 18 vuotta tyttneit lapsia ei oteta malliin.
 - Jos TILANNE = 3, alle 3-vuotiaat lapset ovat hoitolapsia.
*/

%LET MINIMI_KOKO_PUOLISO = 0;
%LET MINIMI_KOKO_LAPSIA_ALLE3 = 0;
%LET MINIMI_KOKO_LAPSIA_3_6 = 0;
%LET MINIMI_KOKO_LAPSIA_7_9 = 0;
%LET MINIMI_KOKO_LAPSIA_10_15 = 0;
%LET MINIMI_KOKO_LAPSIA_16 = 0;
%LET MINIMI_KOKO_LAPSIA_17 = 0;

/* 2.2 Ik */

/*
IKA: Henkiln ik
IKA_PUOL: Puolison ik
Vaikuttaa mm. opintotukeen, tyelke- ja tyttmyysvakuutusmaksuihin
sek sairausvakuutuksen pivrahamaksuun. 
*/

%LET MINIMI_KOKO_IKA = 32;
%LET MINIMI_KOKO_IKA_PUOL = 32;

/* 2.3 Asuinpaikkaan kytkeytyvi tietoja */

/*
Yleisen asumistuen mrytymiseen liittyvt tiedot:

YAKRYHMA:
Yleisen asumistuen kuntaryhm, voi saada arvoja 1-4.
Huom. Kuntien ryhmittely voi muuttua vuosien vlill
eik ryhmien numerointi vlttmtt vastaa
lainsdnnn mukaista numerointia.

Seuraava ryhmittely on voimassa vuosina 2024->:
1 = Helsinki, Espoo, Kauniainen ja Vantaa
2 = Hyvink, Hmeenlinna, Joensuu, Jyvskyl, Jrvenp,
Kajaani, Kerava, Kirkkonummi, Kouvola, Kuopio, Lahti,
Lappeenranta, Lohja, Mikkeli, Nokia, Nurmijrvi, Oulu,
Pori, Porvoo, Raisio, Riihimki, Rovaniemi, Seinjoki,
Sipoo, Siuntio, Tampere, Turku, Tuusula, Vaasa ja Vihti
3 = Muut kunnat

Seuraava ryhmittely oli voimassa vuosina 2015-2023:
1 = Helsinki
2 = Espoo, Kauniainen ja Vantaa
3 = Hyvink, Hmeenlinna, Joensuu, Jyvskyl, Jrvenp,
Kajaani, Kerava, Kirkkonummi, Kouvola, Kuopio, Lahti,
Lappeenranta, Lohja, Mikkeli, Nokia, Nurmijrvi, Oulu,
Pori, Porvoo, Raisio, Riihimki, Rovaniemi, Seinjoki,
Sipoo, Siuntio, Tampere, Turku, Tuusula, Vaasa ja Vihti
4 = Muut kunnat

YALISAKRYHMA (2015->): 
Yleisen asumistuen maakuntaryhm, voi saada arvoja 0-2.
Ryhmittely kertoo, miss maakunnissa asuvat saavat
korotuksen hyvksyttviin lmmitysmenoihin ja
omistusasunnon hoitonormeihin. 
0 = ei korotusta
1 = Etel-Savo, Pohjois-Savo ja Pohjois-Karjala
2 = Pohjois-Pohjanmaa, Kainuu ja Lappi

YALAMMRYHMA (<-2014):
Yleisen asumistuen lmmitysryhm, voi saada arvoja 1-3.
Huom. Kuntien ryhmittely voi muuttua vuosien vlill
eik ryhmien numerointi vlttmtt vastaa
lainsdnnn mukaista numerointia.
Seuraava ryhmittely on voimassa vuonna 2014:
1 = Askola, Aura, Espoo, Eura, Eurajoki, Hamina, Hanko,
Harjavalta, Helsinki, Honkajoki, Huittinen, Hyvink,
Iitti, Imatra, Inkoo, Jmijrvi, Jrvenp, Kaarina,
Kankaanp, Karkkila, Karvia, Kauniainen, Keminsaari,
Kerava, Kirkkonummi, Kokemki, Koski, Kotka, Kouvola,
Kustavi, Kyli, Laitila, Lapinjrvi, Lappeenranta,
Lavia, Lemi, Lito, Lohja, Loimaa, Loviisa, Luumki,
Luvia, Marttila, Masku, Merikarvia, Miehikkl, Mynmki,
Myrskyl, Mntsl, Naantali, Nakkila, Nousiainen,
Nurmijrvi, Orimattila, Orip, Paimio, Parainen,
Parikkala, Pomarkku, Pori, Pornainen, Porvoo,
Pukkila, Punkalaidun, Pyht, Pyhranta, Pyty,
Raasepori, Raisio, Rauma, Rautjrvi, Ruokolahti,
Rusko, Salo, Sastamala, Sauvo, Savitaipale, Siikainen,
Sipoo, Siuntio, Somero, Skyl, Taipalsaari, Taivassalo,
Tarvasjoki, Turku, Tuusula, Ulvila, Uusikaupunki,
Vantaa, Vehmaa, Vihti ja Virolahti
2 = Akaa, Alajrvi, Alavus, Asikkala, Enonkoski, Evijrvi,
Forssa, Halsua, Hartola, Hattula, Hausjrvi, Heinola,
Heinvesi, Hirvensalmi, Hollola, Humppila, Hmeenkoski,
Hmeenkyr, Hmeenlinna, Ikaalinen, Ilmajoki, Isojoki,
Isokyr, Jalasjrvi, Janakkala, Jokioinen, Joroinen,
Juupajoki, Juva, Kangasala, Kangasniemi, Kannus, Karijoki,
Kaskinen, Kauhajoki, Kauhava, Kaustinen, Kihni, Kokkola,
Korsns, Kristiinankaupunki, Kruunupyy, Kuortane, Kurikka,
Krkl, Lahti, Laihia, Lappajrvi, Lapua, Lempl,
Lestijrvi, Loppi, Luoto, Maalahti, Mikkeli, Mustasaari,
Mntt-Vilppula, Mntyharju, Nastola, Nokia, Nrpi,
Orivesi, Padasjoki, Parkano, Pedersren kunta, Perho,
Pertunmaa, Pieksmki, Pietarsaari, Pirkkala, Puumala,
Plkne, Rantasalmi, Riihimki, Ruovesi, Savonlinna,
Seinjoki, Soini, Sulkava, Sysm, Tammela, Tampere, Teuva,
Toholampi, Urjala, Uusikaarlepyy, Vaasa, Valkeakoski,
Vesilahti, Veteli, Vimpeli, Virrat, Vyri, Yljrvi,
Ypj ja htri
3 = Muut kunnat

Elkkeensaajan asumistuen mrytymiseen liittyvt tiedot:

EAKRYHMA:
Elkkeensaajan asumistuen kuntaryhm, voi saada arvoja 1-4.
Huom. Kuntien ryhmittely voi muuttua vuosien vlill
eik ryhmien numerointi vlttmtt vastaa
lainsdnnn mukaista numerointia.
Seuraava ryhmittely on voimassa 2015-2017:
1 = Helsinki
2 = Espoo, Kauniainen ja Vantaa
3 = Hyvink, Hmeenlinna, Joensuu, Jyvskyl, Jrvenp,
Kerava, Kirkkonummi, Kouvola, Kuopio, Lahti,
Lappeenranta, Lohja, Nurmijrvi, Oulu,
Pori, Porvoo, Raisio, Riihimki, Rovaniemi, Seinjoki,
Sipoo, Tampere, Turku, Tuusula, Vaasa ja Vihti
4 = Muut kunnat

EALAMMRYHMA:
Elkkeensaajan asumistuen lmmitysryhm, voi saada arvoja 1-3.
Huom. Kuntien ryhmittely voi muuttua vuosien vlill
eik ryhmien numerointi vlttmtt vastaa
lainsdnnn mukaista numerointia.
Seuraava ryhmittely on voimassa vuosina 2015-2017:
1 = Askola, Aura, Espoo, Eura, Eurajoki, Hamina, Hanko,
Harjavalta, Helsinki, Honkajoki, Huittinen, Hyvink,
Iitti, Imatra, Inkoo, Jmijrvi, Jrvenp, Kaarina,
Kankaanp, Karkkila, Karvia, Kauniainen, Keminsaari,
Kerava, Kirkkonummi, Kokemki, Koski, Kotka, Kouvola,
Kustavi, Kyli, Laitila, Lapinjrvi, Lappeenranta, Lemi,
Lieto, Lohja, Loimaa, Loviisa, Luumki, Luvia, Marttila,
Masku, Merikarvia, Miehikkl, Mynmki, Myrskyl, Mntsl,
Naantali, Nakkila, Nousiainen, Nurmijrvi, Orimattila,
Orip, Paimio, Parainen, Parikkala, Pomarkku, Pori,
Pornainen, Porvoo, Pukkila, Punkalaidun, Pyht, Pyhranta,
Pyty, Raasepori, Raisio, Rauma, Rautjrvi, Ruokolahti,
Rusko, Salo, Sastamala, Sauvo, Savitaipale, Siikainen,
Sipoo, Siuntio, Somero, Skyl, Taipalsaari, Taivassalo,
Turku, Tuusula, Ulvila, Uusikaupunki, Vantaa, Vehmaa,
Vihti, Virolahti sek Ahvenanmaan maakunnan kunnat
2 = Akaa, Alajrvi, Alavus, Asikkala, Enonkoski,
Evijrvi, Forssa, Halsua, Hartola, Hattula, Hausjrvi,
Heinola, Heinvesi, Hirvensalmi, Hollola, Humppila,
Hmeenkoski, Hmeenkyr, Hmeenlinna, Ikaalinen,
Ilmajoki, Isojoki, Isokyr, Jalasjrvi, Janakkala,
Jokioinen, Joroinen, Juupajoki, Juva, Kangasala,
Kangasniemi, Kannus, Karijoki, Kaskinen, Kauhajoki,
Kauhava, Kaustinen, Kihni, Kokkola, Korsns,
Kristiinankaupunki, Kruunupyy, Kuortane, Kurikka,
Krkl, Lahti, Laihia, Lappajrvi, Lapua, Lempl,
Lestijrvi, Loppi, Luoto, Maalahti, Mikkeli, Mustasaari,
Mntt-Vilppula, Mntyharju, Nastola, Nokia, Nrpi,
Orivesi, Padasjoki, Parkano, Pedersren kunta, Perho,
Pertunmaa, Pieksmki, Pietarsaari, Pirkkala, Puumala,
Plkne, Rantasalmi, Riihimki, Ruovesi, Savonlinna,
Seinjoki, Soini, Sulkava, Sysm, Tammela, Tampere,
Teuva, Toholampi, Urjala, Uusikaarlepyy, Vaasa,
Valkeakoski, Vesilahti, Veteli, Vimpeli, Virrat,
Vyri, Yljrvi, Ypj ja htri
3 = Muut kunnat

Kuntien kalleusluokitukseen liittyv tieto
(merkityst vuonna 2007 ja sit ennen):

KELRYHMA (<-2007):
Kunnan kalleusluokka, 1/2. 
Huom. Kuntien ryhmittely voi muuttua vuosien vlill.
Seuraava ryhmittely on voimassa vuonna 2007:
1 = Brnd, Ecker, Enonteki, Espoo, Finstrm, Fgl,
Geta, Hammarland, Helsinki, Houtskari, Hyrynsalmi,
Hyvink, Hmeenlinna, Ii, Inari, Ini, Joensuu,
Jomala, Jyvskyl, Jrvenp, Kauniainen, Kemi,
Kemijrvi, Keminmaa, Kerava, Kirkkonummi, Kittil,
Kolari, Korppoo, Kumlinge, Kuopio, Kuusamo,
Kkar, Lempland, Lumparland, Maarianhamina, Muonio,
Nauvo, Oulu, Pelkosenniemi, Pello, Posio, Ranua,
Ristijrvi, Rovaniemi, Salla, Saltvik, Savukoski
Simo, Sodankyl, Sottunga, Sund, Tampere, Tervola,
Tornio, Utsjoki, Vaasa, Vantaa, Vrd, Ylitornio,
2 = Muut kunnat

Alueellisiin veroihin liittyvt tiedot:

KUNNVERO: 
Kunnallinen veroprosentti desimaaliprosenttilukuna, > 0, esim. 19.30
999 = sovelletaan keskimrist veroprosenttia

KIKRVERO: 
Kirkollinen veroprosentti desimaaliprosenttilukuna, >= 0, esim. 1.20
0 = kirkollisveroa ei lasketa
999 = sovelletaan keskimrist veroprosenttia
*/

%LET MINIMI_KOKO_YAKRYHMA = 1;
%LET MINIMI_KOKO_YALISAKRYHMA = 0;
%LET MINIMI_KOKO_YALAMMRYHMA = 1;
%LET MINIMI_KOKO_EAKRYHMA = 1;
%LET MINIMI_KOKO_EALAMMRYHMA = 1;	
%LET MINIMI_KOKO_KELRYHMA = 1;
%LET MINIMI_KOKO_KUNNVERO = 7.46;
%LET MINIMI_KOKO_KIRKVERO = 0;

/* 2.4 Asuntoon liittyvi tietoja */

/*
VALMVUOSI: Asunnon valmistumis- tai perusparannusvuosi
PINTALA: Asunnon pinta-ala, (m2)
OMISTUS: Omistusasunto: 0 tai 1: jos 0 asunto tulkitaan vuokra-asunnoksi
OMAKOTI: Omakotitalo: 0 tai 1: jos OMISTUS = 0, ei vaikutusta.
VUOKRA_VASTIKE: e/kk, tulkitaan vuokraksi tai yhtivasikkeeksi makromuuttujan OMISTUS mukaisesti;
VESI: Vesimaksu, (e/kk)
ASKORKO = Asuntolainan korko e/kk; Jos OMISTUS = 0, tll ei ole vaikutusta
*/

%LET MINIMI_KOKO_VALMVUOSI = 1970;
%LET MINIMI_KOKO_PINTALA = 55;
%LET MINIMI_KOKO_OMISTUS = 0;
%LET MINIMI_KOKO_OMAKOTI = 0;
%LET MINIMI_KOKO_VUOKRA_VASTIKE = 750;
%LET MINIMI_KOKO_VESI = 0;
%LET MINIMI_KOKO_ASKOROT = 0;

/* 2.5 Henkiliden elmntilanne (suluissa olevia vaihtoehtoja ei ole viel otettu huomioon)  */ 

/* 2.5.1 Henkiln status */

/*
1 Palkansaaja
2 Tytn (oletus: ansiosidonnainen)
21 Peruspivraha
22 Tymarkkinatuki
3 Sairausvakuutuksen pivraha (oletus: normaali)
31 Vanhempainpivraha (oletus: normaali)
311 Raskausraha (8/2022 lhtien) / idin korotettu vanhempainraha (7/2022 asti)
312 Korotettu vanhempainraha (ei kytss 2015-7/2022)
(32 Osapivraha)
4 Lasten kotihoidon tuki
(41 Osittainen kotihoidon tuki)
5 Opiskelija (oletus: korkeakoulu, itsenisesti asuva, ennen vuoden 2014 syyslukukautta aloittanut)
51 Uusi opiskelija: korkeakoulu, itseninen (vuoden 2014 syyslukukaudella ja sen jlkeen aloittaneet)
52 Opiskelija: keskiaste, itseninen
6 Elkelinen 
7 Leski (lesken jatkoelke ja mahdollinen lapsenelke)

Huomautuksia TILANNE-makromuuttujasta:
 - Jos TILANNE = 1 ja palkkatulot = 0, malli laskee tulottoman
   henkiln tai kotitalouden lapsietuudet, yleisen asumistuen ja toimeentulotuen.
 - Eri tilanteet ovat toisensa poissulkevia.
   Se ei kuitenkaan tarkoita kaikilta osin eri tyyppisten tulojen poissulkevuutta:
	- tyttmll, lasten kotihoidon tuen saajalla, elkelisell ja opiskelijalla voi olla palkkatuloa
	- sairaus- tai vanhempainpivrahan saajalla ei voi olla palkkatuloa
 - Jos tilanteessa 6 on kyse tykyvyttmyyselkelisest, on huomiotava, ett hnen tytulonsa eivt
   saa ylitt tietty rajaa (KANSEL-mallin lakiparametri RajaTyotulo, 737.45 e/kk vuonna 2018)
   tai kansanelke ja takuuelke on jtettv lepmn. Tt huomiointia ei ole esimerkkilaskelmissa
   mukana automaattisesti.
*/

%LET MINIMI_KOKO_TILANNE = 1;

/* 2.5.2 Puolison status */

/*
Jos PUOLISO = 0, ei vaikutusta.
Samat arvot kuin TILANNE-muuttujassa.
*/

%LET MINIMI_KOKO_TILANNE_PUOL = 1;

/* 2.5.3 Lisoletuksia tyttmyysturvaa varten */

/*
KOROTUS: Korotusosa, 0 tai 1
MTURVA: Muutosturvalis/tyllistmisohjelmalis, 0 tai 1
Huom. Korotusosa tulee kummallekin puolisolle, jos kummatkin tyttmi.
AKTIIVI: Aktiivimallin leikkuri, 0 tai 1
TTPAIVAT: Henkillle aiemmin maksettujen tyttmyyspivrahapivien lukumr (kertym)
*/

%LET MINIMI_KOKO_KOROTUS = 0;
%LET MINIMI_KOKO_MTURVA = 0;
%LET MINIMI_KOKO_AKTIIVI = 0;

%LET MINIMI_KOKO_TTPAIVAT = 0;
%LET MAKSIMI_KOKO_TTPAIVAT = 0; 
%LET KYNNYS_KOKO_TTPAIVAT = 10;

/* 2.5.4 Lisoletus toimeentulotukea varten */

/* Toimeentulotukea saaville lisehto koskien sit, lasketaanko mys mahdollinen epidemiakorvaus (0/1) */ 
%LET MINIMI_KOKO_EPIDEMKORVL = 0;

/* 2.6 Palkkatulo (e/kk) */

/*
- Jos TILANNE = 2, tm tulkitaan tyttmyysajan tytuloksi eli sovitelluksi tytuloksi
- Jos TILANNE = 3, tt ei oteta huomioon 
- Jos TILANNE = 4, tm palkka on mahdollinen samanaikaisesti  lasten kotihoidon tuen kanssa.
- Jos TILANNE = 5, tm on opintotukikuukausien aikana saatua palkkaa.
- Jos TILANNE = 6 tai 7, tm on elkekuukausien aikana saatua palkkaa.
*/

%LET MINIMI_KOKO_PALKKA = 0;
%LET MAKSIMI_KOKO_PALKKA = 2500; 
%LET KYNNYS_KOKO_PALKKA = 500;

/* Sama puolisolle. Ei vaikutusta, jos puoliso = 0 */

%LET MINIMI_KOKO_PALKKA_PUOL = 0;
%LET MAKSIMI_KOKO_PALKKA_PUOL = 0; 
%LET KYNNYS_KOKO_PALKKA_PUOL = 500;

/* 2.6.1 Tulonhankkimiskulut, Ay-maksut ja tymatkakulut */

/* Tulonhankkimiskulut (e/kk) */
%LET MINIMI_KOKO_TULONHANKKULUT = 0;
%LET MAKSIMI_KOKO_TULONHANKKULUT = 0;
%LET KYNNYS_KOKO_TULONHANKKULUT = 100;

/* Tulonhankkimiskulut, puoliso (e/kk) */
%LET MINIMI_KOKO_TULONHANKKULUT_PUOL = 0;
%LET MAKSIMI_KOKO_TULONHANKKULUT_PUOL = 0;
%LET KYNNYS_KOKO_TULONHANKKULUT_PUOL = 100;

/* Ay-jsenmaksut (e/kk) */
%LET MINIMI_KOKO_AYMAKSUT = 0;
%LET MAKSIMI_KOKO_AYMAKSUT = 0; 
%LET KYNNYS_KOKO_AYMAKSUT = 10;

/* Ay-jsenmaksut (e/kk), puoliso */
%LET MINIMI_KOKO_AYMAKSUT_PUOL = 0;
%LET MAKSIMI_KOKO_AYMAKSUT_PUOL = 0; 
%LET KYNNYS_KOKO_AYMAKSUT_PUOL = 10;

/* Tymatkakulut (e/kk) */
%LET MINIMI_KOKO_TYOMATKAKULUT = 0;
%LET MAKSIMI_KOKO_TYOMATKAKULUT = 0; 
%LET KYNNYS_KOKO_TYOMATKAKULUT = 200;

/* Tymatkakulut (e/kk), puoliso */
%LET MINIMI_KOKO_TYOMATKAKULUT_PUOL = 0;
%LET MAKSIMI_KOKO_TYOMATKAKULUT_PUOL = 0; 
%LET KYNNYS_KOKO_TYOMATKAKULUT_PUOL = 200;

/* 2.6.2 Tuloaskel, jolla tuloa korotetaan marginaaliveroastetta laskettaessa (e/kk) */

%LET MINIMI_KOKO_ASKEL = 1;
%LET MAKSIMI_KOKO_ASKEL = 1; 
%LET KYNNYS_KOKO_ASKEL = 1;

/* 2.7 Tyelke (e/kk) */

/* Tll on vaikutusta vain, jos tilanne = 6 tai 7 */

%LET MINIMI_KOKO_ELAKE = 0;
%LET MAKSIMI_KOKO_ELAKE = 0; 
%LET KYNNYS_KOKO_ELAKE = 250;

/* Sama puolisolle. Ei vaikutusta, jos puoliso = 0 */

%LET MINIMI_KOKO_ELAKE_PUOL = 0;
%LET MAKSIMI_KOKO_ELAKE_PUOL = 0; 
%LET KYNNYS_KOKO_ELAKE_PUOL = 250;

/* 2.8 Pivrahan perusteena oleva bruttopalkka ennen vhennyksi (e/kk) */

/*
- Jos TILANNE = 2 tai 3, tm tulkitaan tukijaksoa edeltvksi palkaksi, johon pivrahan suuruus perustuu. 
  Tllin jos EDPALKKA = 0, lasketaan peruspivraha tai vanhenpainrahan tapauksessa minimipivraha.
  Sairauspivrahan tapauksessa tmn tulee olla suurempi kuin 0 tai muuten sairauspivrahaa ei lasketa.
- Jos TILANNE = 1, 4, 5, 6 tai 7, tt ei oteta huomioon
- Pivrahan laskuvaiheessa tst palkasta vhennetn vakuutusmaksuvhennys ja tulonhankkimisvhennys, jonka
  arvoksi oletetaan viran puolesta vhennettv minimimr.
*/

%LET MINIMI_KOKO_EDPALKKA = 0;
%LET MAKSIMI_KOKO_EDPALKKA = 0;
%LET KYNNYS_KOKO_EDPALKKA = 100;

/* Sama puolisolle. Ei vaikutusta, jos PUOLISO = 0 */

%LET MINIMI_KOKO_EDPALKKA_PUOL = 0;
%LET MAKSIMI_KOKO_EDPALKKA_PUOL = 0;
%LET KYNNYS_KOKO_EDPALKKA_PUOL = 100;

%END;

/* 2.9 Muuttujien johdonmukaisuuden varmistaminen, varoitukset */

/* Asuntolainan korot otetaan huomioon vain omistusasunnosa */

%IF &MINIMI_KOKO_OMISTUS = 0 AND &MINIMI_KOKO_ASKOROT NE 0 %THEN %PUT WARNING: Asuntolainan korot otetaan huomioon vain omistusasunnosa;

/* Helsinki on aina kuulunut kalleusluokkaan 1 */

%IF (&MINIMI_KOKO_YAKRYHMA = 1 AND &MINIMI_KOKO_EAKRYHMA = 1) AND &MINIMI_KOKO_KELRYHMA NE 1 %THEN %PUT WARNING: Helsinki on aina kuulunut kalleusluokkaan 1 (KELRYHMA);

/* Kotihoidon tukea voi saada puolisoista vain toinen */
/* Jos kyse on puolisoista, viitehenkil ei voi saada kotihoidon tukea */

%IF &MINIMI_KOKO_PUOLISO = 1 AND &MINIMI_KOKO_TILANNE = 4 AND &MINIMI_KOKO_TILANNE_PUOL = 4 %THEN %PUT WARNING: Kotihoidon tukea voi saada puolisoista vain toinen;

/* Korotusosa ja muutosturva eivt pde yhtaikaa */

%IF &MINIMI_KOKO_KOROTUS = 1 AND &MINIMI_KOKO_MTURVA = 1 %THEN %PUT WARNING: Korotusosa ja muutosturva eivt pde yhtaikaa;

/* Vuonna 2017 vuosikeskiarvoistaminen ei huomioi oikein opiskelijoiden siirtoa yleiseen asumistukeen */

%IF &VUOSIKA = 1 AND (%SUBSTR(&MINIMI_KOKO_TILANNE, 1, 1) = 5 OR (&MINIMI_KOKO_PUOLISO = 1 AND %SUBSTR(&MINIMI_KOKO_TILANNE_PUOL, 1, 1) = 5)) AND &MINIMI_KOKO_VUOSI <= 2017 AND &MAKSIMI_KOKO_VUOSI >= 2017 %THEN %DO;
	%PUT WARNING: Vuonna 2017 vuosikeskiarvoistaminen ei huomioi oikein opiskelijoiden siirtoa yleiseen asumistukeen;
	%PUT WARNING: Valitse VUOSIKA = 2 ja haluamasi lainsdntkuukausi!;
%END;

/* 2.10 Generoidaan data makromuuttujien arvojen mukaisesti ja tarkastetaan johdonmukaisuus */ 

DATA OUTPUT.&TULOSNIMI_KOKO;

DO KOKO_VUOSI = &MINIMI_KOKO_VUOSI TO &MAKSIMI_KOKO_VUOSI;
DO KOKO_KUUK = &MINIMI_KOKO_KUUK TO &MAKSIMI_KOKO_KUUK;
 KOKO_PUOLISO = &MINIMI_KOKO_PUOLISO ;
 KOKO_LAPSIA_ALLE3 = &MINIMI_KOKO_LAPSIA_ALLE3;
 KOKO_LAPSIA_3_6 = &MINIMI_KOKO_LAPSIA_3_6;
 KOKO_LAPSIA_7_9 = &MINIMI_KOKO_LAPSIA_7_9;
 KOKO_LAPSIA_10_15 = &MINIMI_KOKO_LAPSIA_10_15;
 KOKO_LAPSIA_16 = &MINIMI_KOKO_LAPSIA_16;
 KOKO_LAPSIA_17 = &MINIMI_KOKO_LAPSIA_17;
 KOKO_IKA = &MINIMI_KOKO_IKA;
 KOKO_IKA_PUOL = &MINIMI_KOKO_IKA_PUOL;
 KOKO_YAKRYHMA = &MINIMI_KOKO_YAKRYHMA;
 KOKO_YALISAKRYHMA = &MINIMI_KOKO_YALISAKRYHMA;
 KOKO_YALAMMRYHMA = &MINIMI_KOKO_YALAMMRYHMA;
 KOKO_EAKRYHMA = &MINIMI_KOKO_EAKRYHMA;
 KOKO_EALAMMRYHMA = &MINIMI_KOKO_EALAMMRYHMA;
 KOKO_KELRYHMA = &MINIMI_KOKO_KELRYHMA;
 KOKO_KUNNVERO = &MINIMI_KOKO_KUNNVERO;
 KOKO_KIRKVERO = &MINIMI_KOKO_KIRKVERO;
 KOKO_VALMVUOSI = &MINIMI_KOKO_VALMVUOSI;
 KOKO_PINTALA = &MINIMI_KOKO_PINTALA;
 KOKO_OMISTUS = &MINIMI_KOKO_OMISTUS;
 KOKO_OMAKOTI = &MINIMI_KOKO_OMAKOTI;
 KOKO_VUOKRA_VASTIKE = &MINIMI_KOKO_VUOKRA_VASTIKE;
 KOKO_VESI = &MINIMI_KOKO_VESI;
 KOKO_ASKOROT = &MINIMI_KOKO_ASKOROT;
 KOKO_TILANNE = &MINIMI_KOKO_TILANNE;
 KOKO_TILANNE_PUOL = &MINIMI_KOKO_TILANNE_PUOL;
 KOKO_KOROTUS = &MINIMI_KOKO_KOROTUS;
 KOKO_MTURVA = &MINIMI_KOKO_MTURVA;
 KOKO_AKTIIVI = &MINIMI_KOKO_AKTIIVI;
 KOKO_EPIDEMKORVL = &MINIMI_KOKO_EPIDEMKORVL;

DO KOKO_PALKKA = &MINIMI_KOKO_PALKKA TO &MAKSIMI_KOKO_PALKKA BY &KYNNYS_KOKO_PALKKA;
DO KOKO_TULONHANKKULUT = &MINIMI_KOKO_TULONHANKKULUT TO &MAKSIMI_KOKO_TULONHANKKULUT BY &KYNNYS_KOKO_TULONHANKKULUT;
DO KOKO_AYMAKSUT = &MINIMI_KOKO_AYMAKSUT TO &MAKSIMI_KOKO_AYMAKSUT BY &KYNNYS_KOKO_AYMAKSUT;
DO KOKO_TYOMATKAKULUT = &MINIMI_KOKO_TYOMATKAKULUT TO &MAKSIMI_KOKO_TYOMATKAKULUT BY &KYNNYS_KOKO_TYOMATKAKULUT;
DO KOKO_ELAKE = &MINIMI_KOKO_ELAKE TO &MAKSIMI_KOKO_ELAKE BY &KYNNYS_KOKO_ELAKE;
DO KOKO_EDPALKKA = &MINIMI_KOKO_EDPALKKA TO &MAKSIMI_KOKO_EDPALKKA BY &KYNNYS_KOKO_EDPALKKA;
DO KOKO_ASKEL = &MINIMI_KOKO_ASKEL TO &MAKSIMI_KOKO_ASKEL BY &KYNNYS_KOKO_ASKEL;
DO KOKO_PALKKA_PUOL = &MINIMI_KOKO_PALKKA_PUOL TO &MAKSIMI_KOKO_PALKKA_PUOL BY &KYNNYS_KOKO_PALKKA_PUOL;
DO KOKO_TULONHANKKULUT_PUOL = &MINIMI_KOKO_TULONHANKKULUT_PUOL TO &MAKSIMI_KOKO_TULONHANKKULUT_PUOL BY &KYNNYS_KOKO_TULONHANKKULUT_PUOL;
DO KOKO_AYMAKSUT_PUOL = &MINIMI_KOKO_AYMAKSUT_PUOL TO &MAKSIMI_KOKO_AYMAKSUT_PUOL BY &KYNNYS_KOKO_AYMAKSUT_PUOL;
DO KOKO_TYOMATKAKULUT_PUOL = &MINIMI_KOKO_TYOMATKAKULUT_PUOL TO &MAKSIMI_KOKO_TYOMATKAKULUT_PUOL BY &KYNNYS_KOKO_TYOMATKAKULUT_PUOL;
DO KOKO_EDPALKKA_PUOL = &MINIMI_KOKO_EDPALKKA_PUOL TO &MAKSIMI_KOKO_EDPALKKA_PUOL BY &KYNNYS_KOKO_EDPALKKA_PUOL;
DO KOKO_ELAKE_PUOL = &MINIMI_KOKO_ELAKE_PUOL TO &MAKSIMI_KOKO_ELAKE_PUOL BY &KYNNYS_KOKO_ELAKE_PUOL;
DO KOKO_TTPAIVAT = &MINIMI_KOKO_TTPAIVAT TO &MAKSIMI_KOKO_TTPAIVAT BY &KYNNYS_KOKO_TTPAIVAT;

/* 2.11 Inflaatiokerron */

/* Lasketaan mahdollinen indeksiin perustuva inflaatiokorjaus */
%InfKerroin_ESIM(&AVUOSI, KOKO_VUOSI, &INF);

OUTPUT;
END;END;END;END;END;END;END;END;END;END;END;END;END;END;END;END;

RUN;

%MEND Generoi_Muuttujat;

%Generoi_Muuttujat;

%MACRO Tarkista_Muuttujat;

/* 3. Tarkastetaan generoitu data */
DATA OUTPUT.&TULOSNIMI_KOKO;
SET OUTPUT.&TULOSNIMI_KOKO;

/* 3.1 Tarkistuksia TILANNE-muuttujan mukaisesti */

/* Jos TILANNE ei ole 2, 3, 31, 311 tai 312, EDPALKKA = 0 */
IF KOKO_TILANNE NE 2 AND KOKO_TILANNE NE 3 AND KOKO_TILANNE NE 31 AND KOKO_TILANNE NE 311
	AND KOKO_TILANNE NE 312 THEN KOKO_EDPALKKA = 0;

IF KOKO_TILANNE_PUOL NE 2 AND KOKO_TILANNE_PUOL NE 3 AND KOKO_TILANNE_PUOL NE 31 AND KOKO_TILANNE_PUOL NE 311
	AND KOKO_TILANNE_PUOL NE 312 THEN KOKO_EDPALKKA_PUOL = 0;

/* Jos TILANNE on 3, 31, 311 tai 312, PALKKA = 0 */
IF KOKO_TILANNE = 3 OR KOKO_TILANNE = 31 OR KOKO_TILANNE = 311
	OR KOKO_TILANNE = 312 THEN KOKO_PALKKA = 0;

IF KOKO_TILANNE_PUOL = 3 OR KOKO_TILANNE_PUOL = 31 OR KOKO_TILANNE_PUOL = 311
	OR KOKO_TILANNE_PUOL = 312 THEN KOKO_PALKKA_PUOL = 0;

/* Elketuloa vain, jos TILANNE = 6 tai 7 */
IF KOKO_TILANNE NE 6 AND KOKO_TILANNE NE 7 THEN KOKO_ELAKE = 0;

IF KOKO_TILANNE_PUOL NE 6 AND KOKO_TILANNE NE 7 THEN KOKO_ELAKE_PUOL = 0;

/* Jos PUOLISO = 0, puolison tulot nollataan varmuuden vuoksi */
	
IF KOKO_PUOLISO = 0 THEN DO;
	KOKO_PALKKA_PUOL = 0;
	KOKO_EDPALKKA_PUOL = 0;
	KOKO_ELAKE_PUOL = 0;
	KOKO_TULONHANKKULUT_PUOL = 0;
	KOKO_AYMAKSUT_PUOL = 0;
	KOKO_TYOMATKAKULUT_PUOL = 0;
END;

/* 3.2 Muuttujien johdonmukaisuuden varmistaminen */

/* Asuntolainan korot otetaan huomioon vain omistusasunnosa */

IF KOKO_OMISTUS = 0 THEN KOKO_ASKOROT = 0;

/* Helsinki on aina kuulunut kalleusluokkaan 1 */

IF (KOKO_YAKRYHMA = 1 AND KOKO_EAKRYHMA = 1) THEN KOKO_KELRYHMA = 1;

/* Kotihoidon tukea voi saada puolisoista vain toinen */
/* Jos kyse on puolisoista, viitehenkil ei voi saada kotihoidon tukea */

IF KOKO_PUOLISO = 1 AND KOKO_TILANNE = 4 THEN KOKO_TILANNE = 1;

/* Korotusosa ja muutosturva eivt pde yhtaikaa */

IF KOKO_KOROTUS = 1 THEN KOKO_MTURVA = 0;

/* Opiskelun aloitusajankohdan mritteleminen lakimakroja varten */

IF KOKO_TILANNE = 51 THEN KOKO_ALOITUSPVM = MDY(8,1,2014);
ELSE KOKO_ALOITUSPVM = .;
IF KOKO_TILANNE_PUOL = 51 THEN KOKO_ALOITUSPVM_PUOL = MDY(8,1,2014);
ELSE KOKO_ALOITUSPVM_PUOL = .;

RUN;

/* Poistetaan tuplarivit */
PROC SORT DATA = OUTPUT.&TULOSNIMI_KOKO NODUPRECS; BY _ALL_; RUN;

%MEND Tarkista_Muuttujat;

%Tarkista_Muuttujat;

/* 4. Yksiltason laskenta */

%MACRO KOKO_LASKENTA(onkopuoliso);

/* onkopuoliso-parametri lis muuttujien nimeen _puol-liitteen.
   Jos oletusten mukaan puolisoa ei ole, tll ei ole vaikutusta */

%IF &onkopuoliso = 1 %THEN %LET suff = _PUOL;
%ELSE %LET suff = ;

DATA OUTPUT.&TULOSNIMI_KOKO;
SET OUTPUT.&TULOSNIMI_KOKO;

/* Nollataan sellaisia muuttujia, joita ei vlttmtt aina tuoteta */
TYOTPR&suff = 0;
SAIRPR&suff = 0;
SVHANKVAH&suff = 0;
KOTIHTU&suff = 0;
OPIR&suff = 0;
OPRAHA&suff = 0;
OPLAI&suff = 0;
OPLAINA&suff = 0;
ASLIS&suff = 0;
ASUMLISA&suff = 0;
KANSEL&suff = 0;
TAKUUEL&suff = 0;
LESKENELAK&suff = 0;
ELAKYHT&suff = 0;
LAPSIKORO&suff = 0;
OPINTUKI_TUKIAIKA&suff = 0;
%IF &onkopuoliso = 0 %THEN %DO;
LAPSENELAK = 0;
KOTIHTULOT = 0;
ELATTUKI = 0;
%END;

/* Jos puolison laskennassa puolisoa ei sittenkn ole, niin ohitetaan rivi ja mennn seuraavalle riville */
IF &onkopuoliso = 0 OR (&onkopuoliso = 1 AND KOKO_PUOLISO) THEN DO; /* Puolisocheck */

/* 4.1 Tyttmyyspivrahat */

IF SUBSTRN(KOKO_TILANNE&suff, 1, 1) = 2 THEN DO;

	YHTLAPSIATTURVA&suff = SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15, KOKO_LAPSIA_16, KOKO_LAPSIA_17);

	IF KOKO_TILANNE&suff = 2 THEN DO;

		%IF &VUOSIKA = 2 %THEN %DO;
			%AnsioSidKS (TYOTPR&suff, KOKO_VUOSI, KOKO_KUUK, INF, YHTLAPSIATTURVA&suff, KOKO_KOROTUS, KOKO_MTURVA, 0, KOKO_EDPALKKA&suff, 0, KOKO_TTPAIVAT, 0, aktiivi=KOKO_AKTIIVI);
			IF (KOKO_KOROTUS OR KOKO_MTURVA) AND KOKO_VUOSI >= 2013 THEN DO;
				%AnsioSidKS (TYOTPRIK&suff, KOKO_VUOSI, KOKO_KUUK, INF, YHTLAPSIATTURVA&suff, 0, 0, 0, KOKO_EDPALKKA&suff, 0, KOKO_TTPAIVAT, 0, aktiivi=KOKO_AKTIIVI);
				TYOTKOROSA&suff=SUM(TYOTPR&suff,-TYOTPRIK&suff);
			END;
		%END;
		%ELSE %DO;
			%AnsioSidVS (TYOTPR&suff, KOKO_VUOSI, INF, YHTLAPSIATTURVA&suff, KOKO_KOROTUS, KOKO_MTURVA, 0, KOKO_EDPALKKA&suff, 0, KOKO_TTPAIVAT, 0, aktiivi=KOKO_AKTIIVI);
			IF (KOKO_KOROTUS OR KOKO_MTURVA) AND KOKO_VUOSI >= 2013 THEN DO;
				%AnsioSidVS (TYOTPRIK&suff, KOKO_VUOSI, INF, YHTLAPSIATTURVA&suff, 0, 0, 0, KOKO_EDPALKKA&suff, 0, KOKO_TTPAIVAT, 0, aktiivi=KOKO_AKTIIVI);
				TYOTKOROSA&suff=SUM(TYOTPR&suff,-TYOTPRIK&suff);
			END;
		%END;
	END;
	ELSE IF KOKO_TILANNE&suff = 21 THEN DO;

		%IF &VUOSIKA = 2 %THEN %DO;
			%PerusPRahaKS (TYOTPR&suff, KOKO_VUOSI, KOKO_KUUK, INF, 0, (KOKO_KOROTUS OR KOKO_MTURVA), KOKO_PUOLISO, YHTLAPSIATTURVA&suff, 0, 0, 0, aktiivi=KOKO_AKTIIVI);
		%END;
		%ELSE %DO;
			%PerusPRahaVS (TYOTPR&suff, KOKO_VUOSI, INF, 0, (KOKO_KOROTUS OR KOKO_MTURVA), KOKO_PUOLISO, YHTLAPSIATTURVA&suff, 0, 0, 0, aktiivi=KOKO_AKTIIVI);
		%END;
		IF (KOKO_KOROTUS OR KOKO_MTURVA) AND KOKO_VUOSI >= 2013 THEN TYOTKOROSA&suff = &TTPaivia * &KorotusOsa;
	END;
	ELSE IF KOKO_TILANNE&suff = 22 THEN DO; 

    	%IF &VUOSIKA = 2 %THEN %DO; 
			%IF (&onkopuoliso = 0) %THEN %DO;
               	%TyomTukiKS (TYOTPR&suff, KOKO_VUOSI, KOKO_KUUK, INF, 1, 0, KOKO_PUOLISO, YHTLAPSIATTURVA&suff, 0, 0, KOKO_PALKKA_PUOL, 0, (KOKO_KOROTUS OR KOKO_MTURVA), 0, aktiivi=KOKO_AKTIIVI); 
			%END;
			%ELSE %DO;
				%TyomTukiKS (TYOTPR&suff, KOKO_VUOSI, KOKO_KUUK, INF, 1, 0, KOKO_PUOLISO, YHTLAPSIATTURVA&suff, 0, 0, SUM(KOKO_PALKKA, TYOTPR), 0, (KOKO_KOROTUS OR KOKO_MTURVA), 0, aktiivi=KOKO_AKTIIVI); 
            %END; 
		%END;
        %ELSE %DO; 
			%IF (&onkopuoliso = 0) %THEN %DO;
           		%TyomTukiVS (TYOTPR&suff, KOKO_VUOSI, INF, 1, 0, KOKO_PUOLISO, YHTLAPSIATTURVA&suff, 0, 0, KOKO_PALKKA_PUOL , 0, (KOKO_KOROTUS OR KOKO_MTURVA), 0, aktiivi=KOKO_AKTIIVI); 
			%END;
			%ELSE %DO;
				%TyomTukiVS (TYOTPR&suff, KOKO_VUOSI, INF, 1, 0, KOKO_PUOLISO, YHTLAPSIATTURVA&suff, 0, 0, SUM(KOKO_PALKKA, TYOTPR), 0, (KOKO_KOROTUS OR KOKO_MTURVA), 0, aktiivi=KOKO_AKTIIVI); 
			%END;
		 %END; 
		 IF (KOKO_KOROTUS OR KOKO_MTURVA) AND KOKO_VUOSI >= 2013 THEN TYOTKOROSA&suff = &TTPaivia * &KorotusOsa;
      END;


	/* 4.1.1 Sovitellut pivrahat */

	IF KOKO_PALKKA&suff > 0 THEN DO;

		%IF &VUOSIKA = 2 %THEN %DO;
			%SoviteltuKS (TYOTPR&suff, KOKO_VUOSI, KOKO_KUUK, INF, IFN(KOKO_TILANNE&suff = 2, 1, 0), (KOKO_KOROTUS OR KOKO_MTURVA), YHTLAPSIATTURVA&suff, TYOTPR&suff, KOKO_PALKKA&suff, KOKO_EDPALKKA&suff, 0, aktiivi=KOKO_AKTIIVI);
		%END;
		%ELSE %DO;
			%SoviteltuVS (TYOTPR&suff, KOKO_VUOSI, INF, IFN(KOKO_TILANNE&suff = 2, 1, 0), (KOKO_KOROTUS OR KOKO_MTURVA), YHTLAPSIATTURVA&suff, TYOTPR&suff, KOKO_PALKKA&suff, KOKO_EDPALKKA&suff, 0, aktiivi=KOKO_AKTIIVI);
		%END;
	END;
	IF TYOTKOROSA&suff THEN TYOTKOROSA&suff = MAX(0, MIN(TYOTKOROSA&suff, TYOTPR&suff));
END;

/* 4.2 Sairausvakuutuksen pivrahat */

IF SUBSTRN(KOKO_TILANNE&suff, 1, 1) = 3 THEN DO;

	YHTLAPSIASAIRVAK&suff = SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15);

	/* Lasketaan tulonhankkimiskulut muuttujaan SVHANKVAH*/

	%TulonHankKulutS(SVHANKVAH&suff, KOKO_VUOSI, INF, 12*SUM(KOKO_EDPALKKA&suff),
		0, 0, 0, 0);

	/* Vuodesta 2020 eteenpin sairauspivrahan laskennassa ei huomioida tulonhankkimiskuluja */

	IF KOKO_VUOSI >= 2020 THEN DO;
		SVHANKVAH&suff = 0;
	END;

	TULO&suff =  MAX(12 * KOKO_EDPALKKA&suff, 0);

	/* 4.2.1 Tavallinen sairauspivraha tai osapivraha */

	IF KOKO_TILANNE&suff = 3 OR KOKO_TILANNE&suff = 32 THEN DO;

		%IF &VUOSIKA = 2 %THEN %DO;
			%SairVakPrahaKS (SAIRPR&suff, KOKO_VUOSI, KOKO_KUUK, INF, 0, YHTLAPSIASAIRVAK&suff, TULO&suff, tulonhankk = SVHANKVAH&suff);
		%END;
		%ELSE %DO;
			%SairVakPrahaVS (SAIRPR&suff, KOKO_VUOSI, INF, 0, YHTLAPSIASAIRVAK&suff, TULO&suff, tulonhankk = SVHANKVAH&suff);
		%END;
	END;

	/* 4.2.2 Normaali vanhempainpivraha */

	IF KOKO_TILANNE&suff = 31 THEN DO;

		%IF &VUOSIKA = 2 %THEN %DO;
			%SairVakPrahaKS (SAIRPR&suff, KOKO_VUOSI, KOKO_KUUK, INF, 1, YHTLAPSIASAIRVAK&suff, TULO&suff, tulonhankk = SVHANKVAH&suff);
		%END;
		%ELSE %DO;
			%SairVakPrahavS (SAIRPR&suff, KOKO_VUOSI, INF, 1, YHTLAPSIASAIRVAK&suff, TULO&suff, tulonhankk = SVHANKVAH&suff);
		%END;
	END;
	
	/* 4.2.3 Raskauspivraha 40 pivlt 08/2022 alkaen; itiysraha 56 ensimmiselt pivlt (07/2022 asti); 90 %:n kerroin */

	IF KOKO_TILANNE&suff = 311 THEN DO;

		%IF &VUOSIKA = 2 %THEN %DO;
			%KorVanhRahaKS (SAIRPR&suff, KOKO_VUOSI, KOKO_KUUK, INF, 1, YHTLAPSIASAIRVAK&suff, TULO&suff, tulonhankk = SVHANKVAH&suff);
		%END;
		%ELSE %DO;
			%KorVanhRahavS (SAIRPR&suff, KOKO_VUOSI, INF, 1, YHTLAPSIASAIRVAK&suff, TULO&suff, tulonhankk = SVHANKVAH&suff);
		%END;
	END;

	/* 4.2.4 Korotettu vanhempainraha; 75 %:n kerroin 2015 asti. 90 % kerroin 08/2022 alkaen */

	IF KOKO_TILANNE&suff = 312 THEN DO;

		%IF &VUOSIKA = 2 %THEN %DO;
			 %KorVanhRahaKS (SAIRPR&suff, KOKO_VUOSI, KOKO_KUUK, INF, 0, YHTLAPSIASAIRVAK&suff, TULO&suff, tulonhankk = SVHANKVAH&suff);
		%END;
		%ELSE %DO;
			%KorVanhRahaVS (SAIRPR&suff, KOKO_VUOSI, INF, 0, YHTLAPSIASAIRVAK&suff, TULO&suff, tulonhankk = SVHANKVAH&suff);
		%END;
	END;

	/* 4.2.5 Osapivraha puolet normaalista sairauspivrahasta */

	IF KOKO_TILANNE&suff = 32 THEN DO;

	    SAIRPR&suff = 0.5 * SAIRPR&suff;

	END;

END;

/* 4.3 Opintotuki */

/* 4.3.1 Opintoraha ja -laina */
/*Tuki lasketaan tulojen perusteella niin, ett laskennassa kytetn maksimimr mink henkil voisi 
opintukea muiden tulojen jlkeen nostaa*/
/* Lasketaan mys opintolaina, jota kytetn toimeentulotuen laskennassa */

IF SUBSTRN(KOKO_TILANNE&suff, 1, 1) = 5 THEN DO;

	ONHUOLTAJA&suff = IFN(SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15, KOKO_LAPSIA_16, KOKO_LAPSIA_17) > 0, 1, 0);
	
	/* Tukikuukausien mr tulojen perusteella */

	%TukiKuukOik (OPINTUKI_TUKIAIKA&suff, KOKO_VUOSI, KOKO_KUUK, INF, KOKO_PALKKA&suff * 12, 12);

	%IF &VUOSIKA = 2 %THEN %DO;
		%OpRahaKS (OPIR&suff, KOKO_VUOSI, KOKO_KUUK, INF, (KOKO_TILANNE&suff NE 52), 0, KOKO_IKA&suff, 0, 12* KOKO_PALKKA&suff, 0, 0, 0, aloituspvm=KOKO_ALOITUSPVM&suff, huoltaja=ONHUOLTAJA&suff);
		%OpRahaKS (OPIR_ILMHUOLT&suff, KOKO_VUOSI, KOKO_KUUK, INF, (KOKO_TILANNE&suff NE 52), 0, KOKO_IKA&suff, 0, 12* KOKO_PALKKA&suff, 0, 0, 0, aloituspvm=KOKO_ALOITUSPVM&suff, huoltaja=0);
		%OpRahaKS (OPIR_ILMOP&suff, KOKO_VUOSI, KOKO_KUUK, INF, (KOKO_TILANNE&suff NE 52), 0, KOKO_IKA&suff, 0, 12* KOKO_PALKKA&suff, 0, 0, 0, aloituspvm=KOKO_ALOITUSPVM&suff, huoltaja=ONHUOLTAJA&suff, oppimateriaali=0);		
		%OpRahaKS (OPIR_ILMHUOLTOP&suff, KOKO_VUOSI, KOKO_KUUK, INF, (KOKO_TILANNE&suff NE 52), 0, KOKO_IKA&suff, 0, 12* KOKO_PALKKA&suff, 0, 0, 0, aloituspvm=KOKO_ALOITUSPVM&suff, huoltaja=0, oppimateriaali=0);
	%END;
	%ELSE %DO;
		%OpRahaVS (OPIR&suff, KOKO_VUOSI, INF, (KOKO_TILANNE&suff NE 52), 0, KOKO_IKA&suff, 0, 12* KOKO_PALKKA&suff, 0, 0, 0, aloituspvm=KOKO_ALOITUSPVM&suff, huoltaja=ONHUOLTAJA&suff);
		%OpRahaVS (OPIR_ILMHUOLT&suff, KOKO_VUOSI, INF, (KOKO_TILANNE&suff NE 52), 0, KOKO_IKA&suff, 0, 12* KOKO_PALKKA&suff, 0, 0, 0, aloituspvm=KOKO_ALOITUSPVM&suff, huoltaja=0);
		%OpRahaVS (OPIR_ILMOP&suff, KOKO_VUOSI, INF, (KOKO_TILANNE&suff NE 52), 0, KOKO_IKA&suff, 0, 12* KOKO_PALKKA&suff, 0, 0, 0, aloituspvm=KOKO_ALOITUSPVM&suff, huoltaja=ONHUOLTAJA&suff, oppimateriaali=0);
		%OpRahaVS (OPIR_ILMHUOLTOP&suff, KOKO_VUOSI, INF, (KOKO_TILANNE&suff NE 52), 0, KOKO_IKA&suff, 0, 12* KOKO_PALKKA&suff, 0, 0, 0, aloituspvm=KOKO_ALOITUSPVM&suff, huoltaja=0, oppimateriaali=0);
	%END;

	/*Nollataan opintotuki henkililt, jotka eivt siihen ole tulojensa puolesta oikeutettuja*/
	IF OPINTUKI_TUKIAIKA&suff = 0 THEN DO;
		OPIR&suff = 0;
		OPIR_ILMHUOLT&suff = 0;
		OPIR_ILMOP&suff = 0;
		OPIR_ILMHUOLTOP&suff = 0;
	END;
	/* Kuukausikeskiarvo */
	OPRAHA&suff = OPIR&suff * OPINTUKI_TUKIAIKA&suff / 12;
	OPRAHA_ILMHUOLT&suff = OPIR_ILMHUOLT&suff * OPINTUKI_TUKIAIKA&suff / 12;
	OPRAHA_ILMOP&suff = OPIR_ILMOP&suff * OPINTUKI_TUKIAIKA&suff / 12;
	OPRAHA_ILMHUOLTOP&suff = OPIR_ILMHUOLTOP&suff * OPINTUKI_TUKIAIKA&suff / 12;

	%IF &VUOSIKA = 2 %THEN %DO;
		%OpLainaKS (OPLAI&suff, KOKO_VUOSI, KOKO_KUUK, INF, (KOKO_TILANNE&suff NE 52), 0, KOKO_IKA&suff);
	%END;
	%ELSE %DO;
		%OpLainaVS (OPLAI&suff, KOKO_VUOSI, INF, (KOKO_TILANNE&suff NE 52), 0, KOKO_IKA&suff);
	%END;

	/*Nollataan opintolaina henkililt, jotka eivt siihen ole tulojensa puolesta oikeutettuja*/
	IF OPINTUKI_TUKIAIKA&suff = 0 THEN OPLAI&suff = 0;
	/* Kuukausikeskiarvo */
	OPLAINA&suff = OPLAI&suff * OPINTUKI_TUKIAIKA&suff / 12;
END;

/* 4.3.2 Opintotuen asumislis */

/* Opintotuen asumislis lasketaan henkilkohtaisena tulona, jos TILANNE on  (5, 51),
   jos asunto vuokra-asunto ja jos henkilll tai puolisoilla ei ole lapsia.
   Yhteislaskennassa hyvksytn puolisoille vain jos kumpikin puoliso on opiskelija.
   Omistusasuntoon asumislis ei lasketa. */

IF SUBSTRN(KOKO_TILANNE&suff, 1, 1) = 5 AND KOKO_OMISTUS = 0 AND 
	SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15, KOKO_LAPSIA_16, KOKO_LAPSIA_17) = 0
	THEN DO;

	/* Puolisoilla vuokra puolitetaan asumislisn erikseen laskemista varten */

	IF KOKO_PUOLISO = 1 THEN VUOKRA = KOKO_VUOKRA_VASTIKE/2;
	ELSE VUOKRA = KOKO_VUOKRA_VASTIKE;

	%IF &VUOSIKA = 2 %THEN %DO;
		%AsumLisaKS (ASLIS&suff, KOKO_VUOSI, KOKO_KUUK, INF, (KOKO_TILANNE&suff NE 52), KOKO_IKA&suff, 0, VUOKRA, KOKO_PALKKA&suff, 0, 0, 0);
	%END;
	%ELSE %DO;
		%AsumLisaVS (ASLIS&suff, KOKO_VUOSI, INF, (KOKO_TILANNE&suff NE 52), KOKO_IKA&suff, 0, VUOKRA, KOKO_PALKKA&suff, 0, 0, 0);
	%END;
	
	/*Nollataan opintotuen asumislis henkililt, jotka eivt siihen ole tulojensa puolesta oikeutettuja*/
	IF OPINTUKI_TUKIAIKA&suff = 0 THEN ASLIS&suff = 0;
	/* Kuukausikeskiarvo */
	ASUMLISA&suff = ASLIS&suff * OPINTUKI_TUKIAIKA&suff / 12;
END;

/* 4.4 Kansanelke, takuuelke ja elkkeensaajan lapsikorotukset */

IF KOKO_TILANNE&suff = 6 THEN DO;

	%IF &VUOSIKA = 2 %THEN %DO;
		%Kansanelake_SimpleKS (KANSEL&suff, KOKO_VUOSI, KOKO_KUUK, INF, 0, KOKO_PUOLISO, KOKO_KELRYHMA, 12*KOKO_ELAKE&suff, 1);
		%TakuuElakeKS (TAKUUEL&suff, KOKO_VUOSI, KOKO_KUUK, INF, SUM(KOKO_ELAKE&suff, KANSEL&suff), 1);
	%END;
	%ELSE %DO;
		%Kansanelake_SimpleVS (KANSEL&suff, KOKO_VUOSI, INF, 0, KOKO_PUOLISO, KOKO_KELRYHMA, 12*KOKO_ELAKE&suff, 1);
		%TakuuElakeVS (TAKUUEL&suff, KOKO_VUOSI, INF, SUM(KOKO_ELAKE&suff, KANSEL&suff), 1);

	%END;
	ELAKYHT&suff = SUM(KOKO_ELAKE&suff, KANSEL&suff, TAKUUEL&suff);

	/* Lasketaan elkkeensaajien lapsikorotukset */
	/* Vain alle 16-vuotiaat lapset otetaan huomioon */

	ELLAPSIA = SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15);

	%IF &VUOSIKA = 2 %THEN %DO;
		%KanselLisatKS (LAPSIKORO&suff, KOKO_VUOSI, KOKO_KUUK, INF, 1, 0, 0, 0, 0,0, 0, 0, KOKO_KELRYHMA, ELLAPSIA); 
	%END;
	%ELSE %DO;
		%KanselLisatVS (LAPSIKORO&suff, KOKO_VUOSI, INF, 1, 0, 0, 0, 0,0, 0, 0, KOKO_KELRYHMA, ELLAPSIA);
	%END;
END;

/* 4.5 Lesken jatkoelke */

IF KOKO_TILANNE&suff = 7 THEN DO;

	LESKLAPSIA = SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15, KOKO_LAPSIA_16, KOKO_LAPSIA_17);

	%IF &VUOSIKA = 2 %THEN %DO;
		%LeskenElakeAKS(LESKENELAK&suff, KOKO_VUOSI, KOKO_KUUK, INF, 0, KOKO_PUOLISO, KOKO_KELRYHMA, LESKLAPSIA, KOKO_PALKKA&suff*12, 0, KOKO_ELAKE&suff*12, 0);
		%LapsenelakeAKS(LAPSENELAK, KOKO_VUOSI, KOKO_KUUK, INF, 0, 0, 0);
	%END;
	%ELSE %DO;
		%LeskenElakeAVS(LESKENELAK&suff, KOKO_VUOSI, INF, 0, KOKO_PUOLISO, KOKO_KELRYHMA, LESKLAPSIA, KOKO_PALKKA&suff*12, 0, KOKO_ELAKE&suff*12, 0);
		%LapsenelakeAVS(LAPSENELAK, KOKO_VUOSI, INF, 0, 0, 0);
	%END;

	LAPSENELAK = LAPSENELAK * LESKLAPSIA;
	ELAKYHT&suff = SUM(KOKO_ELAKE&suff, LESKENELAK&suff);

END;

/* 4.6 Elatustuki */

/* Lasten lukumr elatustukea (ja asumistukia) varten */

KOKO_LAPSIAYHT = SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15, KOKO_LAPSIA_16, KOKO_LAPSIA_17);

/* Jos yksinhuoltaja, lasketaan elatustuki */

IF KOKO_PUOLISO = 0 AND KOKO_LAPSIAYHT > 0 AND KOKO_TILANNE NE 7 THEN DO;

	%IF &VUOSIKA = 2 %THEN %DO;
		%ElatTukiKS (ELATTUKI, KOKO_VUOSI, KOKO_KUUK, INF, 0, KOKO_LAPSIAYHT);
		* Alle 3-vuotiaista maksetut elatustuet kotihoidon tuen hoitolisn laskemista varten;
		%ElatTukiKS (ELATTUKI_ALLE3, KOKO_VUOSI, KOKO_KUUK, INF, 0, KOKO_LAPSIA_ALLE3);
		* Yhden lapsen elatustuki pivhoitomaksujen laskentaa varten;
		%ElatTukiKS (ELATTUKI_YKSILAPSI, KOKO_VUOSI, KOKO_KUUK, INF, 0, 1);
	%END;
	%ELSE %DO;
		%ElatTukiVS (ELATTUKI, KOKO_VUOSI, INF, 0, KOKO_LAPSIAYHT);
		* Alle 3-vuotiaista maksetut elatustuet kotihoidon tuen hoitolisn laskemista varten;
		%ElatTukiVS (ELATTUKI_ALLE3, KOKO_VUOSI, INF, 0, KOKO_LAPSIA_ALLE3);
		* Yhden lapsen elatustuki pivhoitomaksujen laskentaa varten;
		%ElatTukiVS (ELATTUKI_YKSILAPSI, KOKO_VUOSI, INF, 0, 1);
	%END;
END;

/* 4.7 Kotihoidon tuki */

/* Kotihoidon tuki voidaan laskea vasta kun kummankin puolison muut veronalaiset tulot ovat tiedossa.
   Jos kyse on puolisoista, laskenta tapahtuu vain kun KOKO_TILANNE_PUOL = 4 ja &onkopuoliso = 1.
   Tllin vain puolisolla voi olla kotihoidon tukea, ei viitehenkilll.
   Lisksi edellytetn, ett kotitaloudessa on alle 3-vuotiaita lapsia */

IF ((KOKO_TILANNE = 4 AND KOKO_PUOLISO = 0 AND &onkopuoliso = 0) OR (KOKO_TILANNE_PUOL = 4 
	AND KOKO_PUOLISO = 1 AND &onkopuoliso = 1)) AND KOKO_LAPSIA_ALLE3 > 0 THEN DO;
		
	* Elatustuet otetaan huomioon hoitolisn perusteena olevassa tulossa 1.3.2017 eteenpin;
	IF KOKO_VUOSI > 2017 THEN ELTUKI_HLISA = ELATTUKI_ALLE3;
	ELSE ELTUKI_HLISA = 0;
	%IF &VUOSIKA = 1 %THEN %DO;
		IF KOKO_VUOSI = 2017 THEN ELTUKI_HLISA = 2/12 * ELATTUKI_ALLE3;
	%END;
	%IF &VUOSIKA = 2 %THEN %DO;
		IF KOKO_VUOSI = 2017 AND KOKO_KUUK < 3 THEN ELTUKI_HLISA = ELATTUKI_ALLE3;
	%END;

	* Hoitolisn perusteena oleva tulo;
	KOTIHTULOT = SUM(KOKO_PALKKA, KOKO_PALKKA_PUOL, SAIRPR, SAIRPR_PUOL, TYOTPR, TYOTPR_PUOL, ELAKYHT, ELAKYHT_PUOL, ELTUKI_HLISA);
	
	SISARIA = MAX(KOKO_LAPSIA_ALLE3 - 1, 0);

	KOKO = SUM(1, KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, IFN(KOKO_PUOLISO, 1, 0));

	%IF &VUOSIKA = 2 %THEN %DO;
		%KotihTukiKS (KOTIHTU&suff, KOKO_VUOSI, KOKO_KUUK, INF, SISARIA, KOKO_LAPSIA_3_6, KOKO, KOTIHTULOT, 0);
	%END;
	%ELSE %DO;
		%KotihTukiVS (KOTIHTU&suff, KOKO_VUOSI, INF, SISARIA, KOKO_LAPSIA_3_6, KOKO, KOTIHTULOT, 0);
	%END;
END;

/* 4.8 Verotus */

/* Elkevakuutusmaksu ja muut palkasta perittvt maksut */

%TyoelMaksuS(TYOEL&suff, KOKO_VUOSI, INF, KOKO_IKA&suff, 12*KOKO_PALKKA&suff);

%TyotMaksuS(TYOTMAKSU&suff, KOKO_VUOSI, INF, KOKO_IKA&suff, 12*KOKO_PALKKA&suff);

%SvPRahaMaksuS(SVPRMAKSU&suff, KOKO_VUOSI, INF, KOKO_IKA&suff, 12*KOKO_PALKKA&suff);

PALKVAK&suff = SUM(TYOEL&suff, TYOTMAKSU&suff, SVPRMAKSU&suff);

/* Tulonhankkimisvhennys */
IF KOKO_PALKKA&suff > 0 THEN DO;
	%TulonHankKulutS(HANKVAH&suff, KOKO_VUOSI, INF, 12*KOKO_PALKKA&suff, 12*KOKO_TULONHANKKULUT&suff, 12*KOKO_AYMAKSUT&suff, 12*KOKO_TYOMATKAKULUT&suff, 0);
END;
ELSE DO;
	HANKVAH&suff = 0;
END;

ANSIOTULO&suff = 12*SUM(KOKO_PALKKA&suff, TYOTPR&suff, SAIRPR&suff, KOTIHTU&suff, OPRAHA&suff, ELAKYHT&suff);

PUHDANSIOTULO&suff = MAX(SUM(ANSIOTULO&suff, -HANKVAH&suff), 0);

/* Ansiotulovhennys (2023-) */
%AnsVahS (ANS&suff, KOKO_VUOSI, INF,  PUHDANSIOTULO&suff, 12*KOKO_PALKKA&suff);

/* Kunnallisverotuksen ansiotulovhennys (-2022) */
%KunnAnsVahS (KUNNANS&suff, KOKO_VUOSI, INF,  PUHDANSIOTULO&suff, ANSIOTULO&suff, 12*KOKO_PALKKA&suff, 12*KOKO_PALKKA&suff, ANSIOTULO&suff);

/* Opintorahavhennys (2023-) */
%OpRahVahS (OPRAHVAH&suff, KOKO_VUOSI, INF, 12*OPRAHA&suff, PUHDANSIOTULO&suff);

/* Kunnallisverotuksen opintorahavhennys (-2022) */
%KunnOpRahVahS (KUNNOPRAHVAH&suff, KOKO_VUOSI, INF, 1, 12*OPRAHA&suff, ANSIOTULO&suff, PUHDANSIOTULO&suff); 

/* Elketulovhennys (2023-) */
%ElTulVahS (ELVAH&suff, KOKO_VUOSI, INF, 12*ELAKYHT&suff, PUHDANSIOTULO&suff);

/* Kunnallisverotuksen elketulovhennys (-2022) */
%KunnElTulVahS (KUNNELVAH&suff, KOKO_VUOSI, INF, KOKO_PUOLISO, 0, 12*ELAKYHT&suff, PUHDANSIOTULO&suff, ANSIOTULO&suff);

/* Valtionverotuksen elketulovhennys (-2022) */
%ValtElTulVahS (VALTELVAH&suff, KOKO_VUOSI, INF, 12*ELAKYHT&suff, PUHDANSIOTULO&suff, ANSIOTULO&suff);

/* Perusvhennykset */
IF KOKO_VUOSI >= 2023 THEN DO; 
	/* Verotettava tulo ennen ja jlkeen perusvhennyksen (2023-) */
	VERTULO1&suff = MAX(SUM(ANSIOTULO&suff, -PALKVAK&suff, -HANKVAH&suff, -ANS&suff, -OPRAHVAH&suff, -ELVAH&suff), 0);
	%PerVahS (PER&suff, KOKO_VUOSI, INF, VERTULO1&suff);
	VERTULO2&suff = MAX(SUM(VERTULO1&suff, -PER&suff), 0);
	KUNNVERTULO2&suff = VERTULO2&suff;
END;
ELSE DO;
	/* Verotettava tulo kunnallisverotuksessa ennen ja jlkeen perusvhennyksen (-2022) */
	KUNNVERTULO1&suff = MAX(SUM(ANSIOTULO&suff, -PALKVAK&suff, -HANKVAH&suff, -KUNNANS&suff, -KUNNOPRAHVAH&suff, -KUNNELVAH&suff), 0);
	%KunnPerVahS (KUNNPER&suff, KOKO_VUOSI, INF, KUNNVERTULO1&suff);
	KUNNVERTULO2&suff = MAX(SUM(KUNNVERTULO1&suff, -KUNNPER&suff), 0);
END;


/* Kunnallisvero */
IF KOKO_KUNNVERO = 999 THEN DO;
	%KunnVeroS (KUNNVERO&suff, KOKO_VUOSI, INF, 1, 18, KUNNVERTULO2&suff);
END;
ELSE DO;
	%KunnVeroS (KUNNVERO&suff, KOKO_VUOSI, INF, 0, KOKO_KUNNVERO, KUNNVERTULO2&suff);
END;

/* Kirkollisvero */
IF KOKO_KIRKVERO = 999 THEN DO;
	%KirkVeroS (KIRKVERO&suff, KOKO_VUOSI, INF, 1, 18, KUNNVERTULO2&suff);
END;
ELSE DO;
	%KirkVeroS (KIRKVERO&suff, KOKO_VUOSI, INF, 0, KOKO_KIRKVERO, KUNNVERTULO2&suff);
END;

/* Sairaanhoitomaksu/sairausvakuutusmaksu */
%SairVakMaksuS (SAIRVAKM&suff, KOKO_VUOSI, INF, KUNNVERTULO2&suff, ELAKYHT&suff, 12*KOKO_PALKKA&suff);

/* Kansanelkevakuutusmaksu */
%KanselVakMaksuS (KANSELM&suff, KOKO_VUOSI, INF, KUNNVERTULO2&suff, 0);

/* Valtionverotuksessa verotettava tulo */
IF KOKO_VUOSI >= 2023 THEN DO;
	VALTVERTULO&suff = VERTULO2&suff;
END;
ELSE DO;
	VALTVERTULO&suff = MAX(SUM(ANSIOTULO&suff, -PALKVAK&suff, -HANKVAH&suff, -VALTELVAH&suff), 0);
END;

/* Valtionvero ennen verosta tehtvi vhennyksi */
%ValtTuloVeroS (VALTVERO&suff, KOKO_VUOSI, INF, VALTVERTULO&suff, 0);

/* Elketulon lisvero */
IF KOKO_VUOSI >= 2023 THEN DO;
	%ElakeLisaVeroS(ELAKELISAVERO&suff, KOKO_VUOSI, INF, 12*ELAKYHT&suff, ELVAH&suff);
END;
ELSE DO;
	%ElakeLisaVeroS(ELAKELISAVERO&suff, KOKO_VUOSI, INF, 12*ELAKYHT&suff, VALTELVAH&suff);
END;

VALTVERO&suff = SUM(VALTVERO&suff, ELAKELISAVERO&suff);	

/* Tytulovhennys ja sen jako eri verolajeihin */
%TyotVahS(TYOTULVAH&suff, KOKO_VUOSI, INF, 12*KOKO_PALKKA&suff, PUHDANSIOTULO&suff, KOKO_IKA&suff)

IF KOKO_VUOSI > 2008 THEN DO;
	%VahennJakoS(VALTVERO_B&suff, KOKO_VUOSI, TYOTULVAH&suff, 1, VALTVERO&suff, KUNNVERO&suff, SAIRVAKM&suff, KANSELM&suff, KIRKVERO&suff, 0);
	%VahennJakoS(KUNNVERO_B&suff, KOKO_VUOSI, TYOTULVAH&suff, 2, VALTVERO&suff, KUNNVERO&suff, SAIRVAKM&suff, KANSELM&suff, KIRKVERO&suff, 0);
	%VahennJakoS(SAIRVAKM_B&suff, KOKO_VUOSI, TYOTULVAH&suff, 3, VALTVERO&suff, KUNNVERO&suff, SAIRVAKM&suff, KANSELM&suff, KIRKVERO&suff, 0);
	%VahennJakoS(KANSELM_B&suff, KOKO_VUOSI, TYOTULVAH&suff, 4, VALTVERO&suff, KUNNVERO&suff, SAIRVAKM&suff, KANSELM&suff, KIRKVERO&suff, 0);
	%VahennJakoS(KIRKVERO_B&suff, KOKO_VUOSI, TYOTULVAH&suff, 5, VALTVERO&suff, KUNNVERO&suff, SAIRVAKM&suff, KANSELM&suff, KIRKVERO&suff, 0);
END;
ELSE DO; 
	VALTVERO_B&suff = MAX(SUM(VALTVERO&suff, -TYOTULVAH&suff), 0);
	KUNNVERO_B&suff = KUNNVERO&suff;
	SAIRVAKM_B&suff = SAIRVAKM&suff;
	KANSELM_B&suff = KANSELM&suff;
	KIRKVERO_B&suff = KIRKVERO&suff;
END;

/* Lapsivhennys ja sen jako eri verolajeihin */
%ValtVerLapsVahS(VALTLAPS&suff, KOKO_VUOSI, INF,  -(KOKO_PUOLISO-1), SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15, KOKO_LAPSIA_16), PUHDANSIOTULO&suff);

IF KOKO_VUOSI > 2014 THEN DO;
	%VahennJakoS(VALTVERO_C&suff, KOKO_VUOSI, VALTLAPS&suff, 1, VALTVERO_B&suff, KUNNVERO_B&suff, SAIRVAKM_B&suff, KANSELM_B&suff, KIRKVERO_B&suff, 0);
	%VahennJakoS(KUNNVERO_C&suff, KOKO_VUOSI, VALTLAPS&suff, 2, VALTVERO_B&suff, KUNNVERO_B&suff, SAIRVAKM_B&suff, KANSELM_B&suff, KIRKVERO_B&suff, 0);
	%VahennJakoS(SAIRVAKM_C&suff, KOKO_VUOSI, VALTLAPS&suff, 3, VALTVERO_B&suff, KUNNVERO_B&suff, SAIRVAKM_B&suff, KANSELM_B&suff, KIRKVERO_B&suff, 0);
	%VahennJakoS(KANSELM_C&suff, KOKO_VUOSI, VALTLAPS&suff, 4, VALTVERO_B&suff, KUNNVERO_B&suff, SAIRVAKM_B&suff, KANSELM_B&suff, KIRKVERO_B&suff, 0);
	%VahennJakoS(KIRKVERO_C&suff, KOKO_VUOSI, VALTLAPS&suff, 5, VALTVERO_B&suff, KUNNVERO_B&suff, SAIRVAKM_B&suff, KANSELM_B&suff, KIRKVERO_B&suff, 0);

END;
ELSE DO; 
	VALTVERO_C&suff = VALTVERO_B&suff;
	KUNNVERO_C&suff = KUNNVERO_B&suff;
	SAIRVAKM_C&suff = SAIRVAKM_B&suff;
	KANSELM_C&suff = KANSELM_B&suff;
	KIRKVERO_C&suff = KIRKVERO_B&suff;
END;

VARSVEROTYHT&suff = MAX(SUM(VALTVERO_C&suff, KUNNVERO_C&suff, SAIRVAKM_C&suff, KANSELM_C&suff, KIRKVERO_C&suff), 0);
VEROTYHT&suff = SUM(VARSVEROTYHT&suff, PALKVAK&suff);

/* Yleisradiovero */
%YleVeroS (YLEVERO&suff, KOKO_VUOSI, INF, 50, PUHDANSIOTULO&suff, 0);

/* Nettokuukausitulo verojen jlkeen */
VEROTYHT&suff = SUM(VEROTYHT&suff, YLEVERO&suff);

NETTOTULO&suff = MAX(SUM(ANSIOTULO&suff, -VEROTYHT&suff), 0)/12;

/* Verojen osuus tuloista */
IF ANSIOTULO&suff THEN VEROJENOSUUS&suff = VEROTYHT&suff / ANSIOTULO&suff * 100;
ELSE VEROJENOSUUS&suff = 0;

DROP testi taulu_: /* Pudotetaan kaikki taulu_-alkuiset */ kkuuk
     kuuknro w y z KOKO SISARIA ELAKELISAVERO&suff LESKLAPSIA TYOTPRIK&suff TULO&suff ELATTUKI_ALLE3 ELTUKI_HLISA;  

END; /* Puolisocheck */

RUN;

%MEND KOKO_LASKENTA;

/* 5. Kotitaloustason laskenta */

%MACRO KOKO_LASKENTA_KOTIT;

DATA OUTPUT.&TULOSNIMI_KOKO;
SET OUTPUT.&TULOSNIMI_KOKO;

/* Nollataan muuttujia, joita ei vlttmtt aina lasketa */
ASUMLISAYHT = 0;
OIKELASUM = 0;
ELASUMTUKI = 0;
ASUMTULO = 0;
PERUSOM = 0;
ASUMTUKI = 0;
PHTULO = 0;
PHMAKSUT = 0;
TOIMTUKI = 0;
EPIDEMKORV = 0;
LAPSLIS = 0;

/* 5.1 Lapsilist */

%IF &VUOSIKA = 2 %THEN %DO;
	%LLisaKS (LAPSLIS, KOKO_VUOSI, KOKO_KUUK, INF, KOKO_PUOLISO, KOKO_LAPSIA_ALLE3, SUM(KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15), KOKO_LAPSIA_16);
%END;
%ELSE %DO;
	%LLisaVS (LAPSLIS, KOKO_VUOSI, INF, KOKO_PUOLISO, KOKO_LAPSIA_ALLE3, SUM(KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15), KOKO_LAPSIA_16);
%END;

/* 5.2 Asuntolainan korkoihin perustuva alijmhvyitys lasketaan kotitaloustasolla.
       Nin vhennyksen mahdollinen siirto ja optimointi puolisoiden kesken otetaan implisiittisesti huomioon */

/* 5.2.1 Vhennyskelpoiset korot (rajoitus vuodesta 2012 lhtien) */

%VahAsKorotS (VAHKOROT, KOKO_VUOSI, INF, 12*KOKO_ASKOROT);

/* 5.2.2 Lasten lukumr vaikuttaa alijmhyvityksen. Verotuksessa alle 17-vuotiaat lapset. */

VEROLAPS = SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15, KOKO_LAPSIA_16);
	
%AlijHyvKotitS(ALIJHYV, KOKO_VUOSI, INF, KOKO_PUOLISO, VEROLAPS, 0, 0, 12*KOKO_ASKOROT, 0, 0);

/* 5.3 Muodostetaan kotitalouden verot ottamalla huomioon, ett alijmhyvitys voidaan vhent
       vain 'varsinaisista' veroista. */

KOTITVARSVEROT = MAX(SUM(VARSVEROTYHT, VARSVEROTYHT_PUOL, -ALIJHYV), 0);

KOTITVEROTYHT = SUM(KOTITVARSVEROT, YLEVERO, YLEVERO_PUOL, PALKVAK, PALKVAK_PUOL);

/* 5.4 Lopullinen verotettu NETTOTULO kotitaloustasolla */

KOTITNETTOTULO = MAX(SUM(ANSIOTULO, ANSIOTULO_PUOL, (12 * LAPSENELAK), -KOTITVEROTYHT), 0)/12;

/* 5.5 Summataan opintotuen asumislist */

ASUMLISAYHT = SUM(ASUMLISA, ASUMLISA_PUOL);

/* 5.6 Elkkeensaajien asumistuki; lasketaan puolisoille vain, jos kumpikin saa elketuloa */

IF (KOKO_TILANNE = 6 OR KOKO_TILANNE = 7) AND (KOKO_PUOLISO = 0 OR KOKO_TILANNE = KOKO_TILANNE_PUOL) THEN DO;

	/* Vuodesta 2015 alkaen elkkeensaajan asumistukea ei voi saada, jos taloudessa on lapsia. */

	IF KOKO_VUOSI < 2015 OR (KOKO_VUOSI >= 2015 AND KOKO_LAPSIAYHT = 0) THEN DO;
		
		OIKELASUM = 1;
		
		%IF &VUOSIKA = 1 %THEN %DO;
			%ElakAsumTukiVS (ELASUMTUKI, KOKO_VUOSI, INF, KOKO_PUOLISO, KOKO_PUOLISO, 0, 0, KOKO_LAPSIAYHT, KOKO_OMAKOTI, 
				KOKO_EALAMMRYHMA, 1, 1, 0, 0, KOKO_PINTALA, KOKO_VALMVUOSI, KOKO_EAKRYHMA, SUM(ANSIOTULO, ANSIOTULO_PUOL), 0, 12*KOKO_VUOKRA_VASTIKE, 12*KOKO_ASKOROT);
		%END;
		%ELSE %IF &VUOSIKA = 2 %THEN %DO;
			%ElakAsumTukiKS (ELASUMTUKI, KOKO_VUOSI, KOKO_KUUK, INF, KOKO_PUOLISO, KOKO_PUOLISO, 0, 0, KOKO_LAPSIAYHT, KOKO_OMAKOTI, 
				KOKO_EALAMMRYHMA, 1, 1, 0, 0, KOKO_PINTALA, KOKO_VALMVUOSI, KOKO_EAKRYHMA, SUM(ANSIOTULO, ANSIOTULO_PUOL), 0, 12*KOKO_VUOKRA_VASTIKE, 12*KOKO_ASKOROT);
		%END;

	END;

END;

/* 5.7 Yleinen asumistuki; ehtona, ett oikeutta elkkeensaajien asumistukeen ei ole.
       Lisksi ennen vuoden 2017 elokuuta perheille, joissa ainakin toinen on opiskelija, mynnetn tukea vain jos perheess on lapsia */

IF (KOKO_LAPSIAYHT > 0 OR (KOKO_VUOSI > 2017 
	%IF &VUOSIKA = 2 %THEN %DO;
	OR (KOKO_VUOSI = 2017 AND KOKO_KUUK >= 8)
	%END;
	OR (SUBSTRN(KOKO_TILANNE, 1, 1) NE 5 AND (KOKO_PUOLISO = 0 OR SUBSTRN(KOKO_TILANNE_PUOL, 1, 1) NE 5)))) AND (OIKELASUM = 0 OR OIKELASUM = .) THEN DO;

	IF KOKO_VUOSI < 2015 THEN DO;
		/* Kotitalouden henkiliden lukumr */
		HENK = KOKO_LAPSIAYHT + IFN(KOKO_PUOLISO, 2, 1);
		/* Asumistuen perusomavastuun laskemista  varten muodostettu tulo */
		/* Opintorahaa ei oteta huomioon */
		%TuloMuokkausS (ASUMTULO, KOKO_VUOSI, INF, KOKO_LAPSIAYHT , HENK, 0, MAX(SUM(ANSIOTULO/12, ANSIOTULO_PUOL/12, -OPRAHA, -OPRAHA_PUOL), 0));
		/* Perusomavastuu */
		%PerusOmaVastS (PERUSOM, KOKO_VUOSI, INF, KOKO_YAKRYHMA, HENK, ASUMTULO);
	END;
	ELSE DO;
		IF KOKO_VESI > 0 THEN EVESI = 1;
		ELSE EVESI = 0;
		ARRAY ASTYOTULOT{*} KOKO_PALKKA KOKO_PALKKA_PUOL;
	END;

	IF KOKO_VUOSI < 2018 THEN DO;
		OPINRAHA_YA_HUOM = MAX(SUM(OPRAHA, OPRAHA_PUOL), 0);
	END;
	ELSE IF (&VUOSIKA = 1 AND KOKO_VUOSI < 2019) OR (&VUOSIKA = 2 AND ((KOKO_VUOSI < 2019) OR (KOKO_VUOSI = 2019 AND KOKO_KUUK < 8))) THEN DO;
		OPINRAHA_YA_HUOM = MAX(SUM(OPRAHA_ILMHUOLT, OPRAHA_ILMHUOLT_PUOL), 0);
	END;
	ELSE DO;
		OPINRAHA_YA_HUOM = MAX(SUM(OPRAHA_ILMHUOLTOP, OPRAHA_ILMHUOLTOP_PUOL), 0);
	END;

	IF KOKO_OMISTUS = 0 THEN DO;

		IF KOKO_VUOSI < 2015 THEN DO;
			%AsumTukiVuokS (ASUMTUKI, KOKO_VUOSI, INF, KOKO_YAKRYHMA, 1, 1, 1, HENK, 0, 
			KOKO_VALMVUOSI, KOKO_PINTALA, PERUSOM, KOKO_VUOKRA_VASTIKE, 0, 0);
		END;
		ELSE DO;
			%IF &VUOSIKA = 2 %THEN %DO;
				%As2015AsumistukiVuokraKS(ASUMTUKI, KOKO_VUOSI, KOKO_KUUK, INF, KOKO_YAKRYHMA, 0, KOKO_VUOKRA_VASTIKE, 0,
				EVESI, 0, KOKO_YALISAKRYHMA, MAX(SUM(ANSIOTULO/12, ANSIOTULO_PUOL/12, -OPRAHA, -OPRAHA_PUOL), 0),
				ASTYOTULOT, IFN(KOKO_PUOLISO, 2, 1), KOKO_LAPSIAYHT, opinraha = OPINRAHA_YA_HUOM);
			%END;
			%ELSE %DO;
				%As2015AsumistukiVuokraVS(ASUMTUKI, KOKO_VUOSI, INF, KOKO_YAKRYHMA, 0, KOKO_VUOKRA_VASTIKE, 0,
				EVESI, 0, KOKO_YALISAKRYHMA, MAX(SUM(ANSIOTULO/12, ANSIOTULO_PUOL/12, -OPRAHA, -OPRAHA_PUOL), 0),
				ASTYOTULOT, IFN(KOKO_PUOLISO, 2, 1), KOKO_LAPSIAYHT, opinraha = OPINRAHA_YA_HUOM);
			%END;
		END;

	END;

	ELSE DO;
		
		IF KOKO_VUOSI < 2015 THEN DO;
			%AsumTukiOmS (ASUMTUKI, KOKO_VUOSI, INF, KOKO_YAKRYHMA, KOKO_YALAMMRYHMA, KOKO_OMAKOTI, 1, 1, HENK, 0, KOKO_VALMVUOSI, 
			KOKO_PINTALA, PERUSOM, KOKO_VUOKRA_VASTIKE, KOKO_VESI, 0, KOKO_ASKOROT, 0);
		END;
		ELSE IF KOKO_OMAKOTI = 0 THEN DO;
			%IF &VUOSIKA = 2 %THEN %DO;
				%As2015AsumistukiOmaOsakeKS(ASUMTUKI, KOKO_VUOSI, KOKO_KUUK, INF, KOKO_YAKRYHMA, 0,
				KOKO_VUOKRA_VASTIKE, 0, EVESI, 0, KOKO_YALISAKRYHMA, KOKO_ASKOROT, MAX(SUM(ANSIOTULO/12, ANSIOTULO_PUOL/12, -OPRAHA, -OPRAHA_PUOL), 0),
				ASTYOTULOT, IFN(KOKO_PUOLISO, 2, 1), KOKO_LAPSIAYHT, opinraha = OPINRAHA_YA_HUOM);
			%END;
			%ELSE %DO;
				%As2015AsumistukiOmaOsakeVS(ASUMTUKI, KOKO_VUOSI, INF, KOKO_YAKRYHMA, 0,
				KOKO_VUOKRA_VASTIKE, 0, EVESI, 0, KOKO_YALISAKRYHMA, KOKO_ASKOROT, MAX(SUM(ANSIOTULO/12, ANSIOTULO_PUOL/12, -OPRAHA, -OPRAHA_PUOL), 0),
				ASTYOTULOT, IFN(KOKO_PUOLISO, 2, 1), KOKO_LAPSIAYHT, opinraha = OPINRAHA_YA_HUOM);
			%END;
		END;
		ELSE DO;
			%IF &VUOSIKA = 2 %THEN %DO;
				%As2015AsumistukiOmaTaloKS(ASUMTUKI, KOKO_VUOSI, KOKO_KUUK, INF, KOKO_YAKRYHMA, 0,
				0, KOKO_YALISAKRYHMA, KOKO_ASKOROT, MAX(SUM(ANSIOTULO/12, ANSIOTULO_PUOL/12, -OPRAHA, -OPRAHA_PUOL), 0),
				ASTYOTULOT, IFN(KOKO_PUOLISO, 2, 1), KOKO_LAPSIAYHT, opinraha = OPINRAHA_YA_HUOM);
			%END;
			%ELSE %DO;
				%As2015AsumistukiOmaTaloVS(ASUMTUKI, KOKO_VUOSI, INF, KOKO_YAKRYHMA, 0,
				0, KOKO_YALISAKRYHMA, KOKO_ASKOROT, MAX(SUM(ANSIOTULO/12, ANSIOTULO_PUOL/12, -OPRAHA, -OPRAHA_PUOL), 0),
				ASTYOTULOT, IFN(KOKO_PUOLISO, 2, 1), KOKO_LAPSIAYHT, opinraha = OPINRAHA_YA_HUOM);
			%END;
		END;

	END;

END;

/* 5.8 Pivhoitomaksut */ 

/* Ehtona on, ett kotitaloudessa on pivhoitoikisi lapsia ja ett henkil on palkkatyss (TILANNE = 1)
   tai opiskelija (TILANNE = 5) kun puolisoa ei ole tai kumpikin puoliso on palkkatyss tai opiskelija.
   Lisksi perheess on oltava alle kouluikisi lapsia. */

IF (KOKO_PUOLISO = 0 AND (KOKO_TILANNE = 1 OR SUBSTRN(KOKO_TILANNE, 1, 1) = 5)) 
     OR (KOKO_PUOLISO = 1 AND (KOKO_TILANNE = 1 OR KOKO_TILANNE = 5)
     AND (KOKO_TILANNE_PUOL = 1 OR SUBSTRN(KOKO_TILANNE_PUOL, 1, 1) = 5)) THEN DO;
	
	IF SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6) > 0 THEN DO;

		PHTULO = SUM(KOKO_PALKKA, KOKO_PALKKA_PUOL, SAIRPR, SAIRPR_PUOL, TYOTPR, TYOTPR_PUOL, ELAKYHT, ELAKYHT_PUOL, ELATTUKI_YKSILAPSI);

		%IF &VUOSIKA = 2 %THEN %DO;
			%SumPHoitoMaksuS(PHMAKSUT, KOKO_VUOSI, KOKO_KUUK, INF, KOKO_PUOLISO, SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6),  
                      SUM(KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15, KOKO_LAPSIA_16), PHTULO);
		%END; 
		%ELSE %DO;
			%SumPHoitoMaksuVS(PHMAKSUT, KOKO_VUOSI, INF, KOKO_PUOLISO, SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6),  
                       SUM(KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15, KOKO_LAPSIA_16), PHTULO);
		%END;
	END;

END;

/* 5.9 Toimeentulotuki, e/kk */

/* Tytulot, e/v */
TYOTULOT = 12 * SUM(KOKO_PALKKA);
TYOTULOT_PUOL = 12 * SUM(KOKO_PALKKA_PUOL);

/* Tytulojen osuus veronalaisista ansiotuloista */
IF ANSIOTULO > 0 THEN TYO_OSUUS = TYOTULOT / ANSIOTULO;
ELSE TYO_OSUUS = 0;
IF ANSIOTULO_PUOL > 0 THEN TYO_OSUUS_PUOL = TYOTULOT_PUOL / ANSIOTULO_PUOL;
ELSE TYO_OSUUS_PUOL = 0;

/* Tytulojen verot, e/v */
TYO_VEROT = TYO_OSUUS * SUM(VARSVEROTYHT, YLEVERO);
TYO_VEROT_PUOL = TYO_OSUUS_PUOL * SUM(VARSVEROTYHT_PUOL, YLEVERO_PUOL);

/* Muiden ansiotulojen verot, e/v */
MUUT_VEROT = (1 - TYO_OSUUS) * SUM(VARSVEROTYHT, YLEVERO);
MUUT_VEROT_PUOL = (1 - TYO_OSUUS_PUOL) * SUM(VARSVEROTYHT_PUOL, YLEVERO_PUOL);

/* Nettotytulot e/kk */
NETTOTYOTULO_AR1 = MAX(SUM(TYOTULOT/12, -TYO_VEROT/12, -PALKVAK/12, -KOKO_TULONHANKKULUT, -KOKO_AYMAKSUT, -KOKO_TYOMATKAKULUT), 0);
NETTOTYOTULO_AR2 = MAX(SUM(TYOTULOT_PUOL/12, -TYO_VEROT_PUOL/12, -PALKVAK_PUOL/12, -KOKO_TULONHANKKULUT_PUOL, -KOKO_AYMAKSUT_PUOL, -KOKO_TYOMATKAKULUT_PUOL), 0);
ARRAY NETTOTYOTULO_AR{*} NETTOTYOTULO_AR1 NETTOTYOTULO_AR2;
NETTOTYOTULO = SUM(NETTOTYOTULO_AR1, NETTOTYOTULO_AR2);

/* Tulonhankkimiskulut */
THKULUT_AR1 = MAX(SUM(KOKO_TULONHANKKULUT, KOKO_AYMAKSUT, KOKO_TYOMATKAKULUT), 0);
THKULUT_AR2 = MAX(SUM(KOKO_TULONHANKKULUT_PUOL, KOKO_AYMAKSUT_PUOL, KOKO_TYOMATKAKULUT_PUOL), 0);
ARRAY THKULUT_AR{*} THKULUT_AR1 THKULUT_AR2;

/* Muita verottomia tuloja */
MUUSEKALTULO = SUM(ELATTUKI, ASUMTUKI, ASUMLISAYHT, ELASUMTUKI, OPLAINA, OPLAINA_PUOL, LAPSIKORO, LAPSIKORO_PUOL);

/* Lasketaan verojen osuus ansiotuloista kun sova-maksuja ei huomioida
	(sova-maksut mukana muuttujassa VEROJENOSUUS, joten ei voida kytt sit) */
IF ANSIOTULO > 0 THEN VOSUUSEISOVA = SUM(VARSVEROTYHT, YLEVERO)/ANSIOTULO;
ELSE VOSUUSEISOVA = 0;

/* Muu nettotulo erotuksena, (e/kk) */
MUUNETTOTULO = MAX(SUM(KOTITNETTOTULO, -NETTOTYOTULO, -KOKO_TULONHANKKULUT, -KOKO_TULONHANKKULUT_PUOL, -KOKO_AYMAKSUT, -KOKO_AYMAKSUT_PUOL, -KOKO_TYOMATKAKULUT, -KOKO_TYOMATKAKULUT_PUOL), 0);

/* Tyttmyysturvan korotusosat nettona, (e/kk) */
TYOTKOROSAT = SUM(TYOTKOROSA * (1 - VOSUUSEISOVA), TYOTKOROSA_PUOL * (1 - VOSUUSEISOVA));

/* Tyttmyysturvan korotusosat muuttuivat etuoikeutetuksi tuloksi toimeentulotuessa 1.1.2013 alkaen. */
IF KOKO_VUOSI >= 2013 THEN MUUNETTOTULO = MAX(SUM(MUUNETTOTULO, -TYOTKOROSAT), 0);

/* Opintorahan oppimateriaalilis nettona, (e/kk) */
OPPIMAT = SUM((OPRAHA-OPRAHA_ILMOP) * (1 - VOSUUSEISOVA), (OPRAHA_PUOL-OPRAHA_ILMOP_PUOL) * (1 - VOSUUSEISOVA));

/* Opintorahan oppimateriaalilis on etuoikeutettu tulo toimeentulotuessa 1.8.2019 alkaen.  */
IF (&VUOSIKA = 1 AND KOKO_VUOSI >= 2019) OR (&VUOSIKA = 2 AND ((KOKO_VUOSI = 2019 AND KOKO_KUUK >= 8) OR (KOKO_VUOSI >= 2020))) THEN MUUNETTOTULO = MAX(SUM(MUUNETTOTULO, -OPPIMAT), 0);

%IF &VUOSIKA = 2 %THEN %DO;
	%ToimTukiKS (TOIMTUKI, KOKO_VUOSI, KOKO_KUUK, INF, KOKO_KELRYHMA, 1, IFN(KOKO_PUOLISO, 2, 1), 0, KOKO_LAPSIA_17,
	SUM(KOKO_LAPSIA_10_15, KOKO_LAPSIA_16), SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9), LAPSLIS, NETTOTYOTULO_AR, SUM(MUUNETTOTULO, MUUSEKALTULO), SUM(KOKO_VUOKRA_VASTIKE, KOKO_VESI), PHMAKSUT, THKULUT_AR);
	/* Epidemiakorvaus */ 
	IF TOIMTUKI > 0 AND KOKO_EPIDEMKORVL = 1 THEN DO;
		%EpidemKorvKS(EPIDEMKORV, KOKO_VUOSI, KOKO_KUUK, INF, SUM(1, KOKO_PUOLISO, KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15, KOKO_LAPSIA_16, KOKO_LAPSIA_17)); 
	END;
%END;
%ELSE %DO;
	%ToimTukiVS (TOIMTUKI, KOKO_VUOSI, INF, KOKO_KELRYHMA, 1, IFN(KOKO_PUOLISO, 2, 1), 0, KOKO_LAPSIA_17,
	SUM(KOKO_LAPSIA_10_15, KOKO_LAPSIA_16), SUM(KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9), LAPSLIS, NETTOTYOTULO_AR, SUM(MUUNETTOTULO, MUUSEKALTULO), SUM(KOKO_VUOKRA_VASTIKE, KOKO_VESI), PHMAKSUT, THKULUT_AR);
	/* Epidemiakorvaus */
	IF TOIMTUKI > 0 AND KOKO_EPIDEMKORVL = 1 THEN DO;
		%EpidemKorvVS(EPIDEMKORV, KOKO_VUOSI, INF, SUM(1, KOKO_PUOLISO, KOKO_LAPSIA_ALLE3, KOKO_LAPSIA_3_6, KOKO_LAPSIA_7_9, KOKO_LAPSIA_10_15, KOKO_LAPSIA_16, KOKO_LAPSIA_17));
	END;
%END;

/* 5.10 Kotitalouden kytettviss oleva tulo, (e/kk) */

/* HUOM! Tm ei sisll opintolainaa eik siit vhennet pivhoitomaksuja */

KAYT_TULO = SUM(KOTITNETTOTULO, LAPSLIS, ELATTUKI, ASUMTUKI, ASUMLISAYHT, ELASUMTUKI, LAPSIKORO, LAPSIKORO_PUOL, TOIMTUKI, EPIDEMKORV);

DROP testi taulu_: /* Pudotetaan kaikki taulu_-alkuiset */ kkuuk lapsia
     sarake kuuknro tunnus1-tunnus4 w y z povnimi1-povnimi4 KOKO 
	 VEROLAPS vahlapsia alijenimm kulkorotx HENK YHTLAPSIATTURVA YHTLAPSIATTURVA_PUOL 
     YHTLAPSIASAIRVAK YHTLAPSIASAIRVAK_PUOL ELLAPSIA VUOKRA TYOTKOROSA TYOTKOROSA_PUOL TYOTKOROSAT
	 KOKO_ALOITUSPVM KOKO_ALOITUSPVM_PUOL ONHUOLTAJA ONHUOLTAJA_PUOL 
	 OPIR_ILMHUOLT OPIR_ILMOP OPIR_ILMHUOLTOP OPIR_ILMHUOLT_PUOL OPIR_ILMOP_PUOL OPIR_ILMHUOLTOP_PUOL 
	 OPRAHA_ILMHUOLT OPRAHA_ILMOP OPRAHA_ILMHUOLTOP OPRAHA_ILMHUOLT_PUOL OPRAHA_ILMOP_PUOL OPRAHA_ILMHUOLTOP_PUOL
	 VOSUUSEISOVA ELATTUKI_YKSILAPSI
	 EVESI TYOTULOT TYOTULOT_PUOL TYO_OSUUS TYO_OSUUS_PUOL TYO_VEROT TYO_VEROT_PUOL
	 MUUT_VEROT MUUT_VEROT_PUOL NETTOTYOTULO_AR1 NETTOTYOTULO_AR2 THKULUT_AR1 THKULUT_AR2
	 OPINRAHA_YA_HUOM OPPIMAT;

RUN;

%MEND KOKO_LASKENTA_KOTIT;

/* 6. Lasketaan marginaaliveroasteet */

%MACRO Koko_Simuloi_MargVero;

/* 6.1 Otetaan talteen alkuperiset tulokset ja nimetn 
       laskennassa tarvittavat tulo- ja verotiedot uudelleen */

DATA TEMP.KOKO_ESIM_MARGVERO ;
SET OUTPUT.&TULOSNIMI_KOKO;
VEROT = VEROTYHT;
KTU = KAYT_TULO;
RUN;

/* 6.2 Simuloidaan malli uudestaan lismll palkkatuloihin askeleen mukainen palkanlis */

%Generoi_Muuttujat;

DATA OUTPUT.&TULOSNIMI_KOKO;
SET OUTPUT.&TULOSNIMI_KOKO;
KOKO_PALKKA = SUM(KOKO_PALKKA, KOKO_ASKEL);
RUN;

%Tarkista_Muuttujat;

%KOKO_LASKENTA(0);
%KOKO_LASKENTA(1);
%KOKO_LASKENTA_KOTIT;

/* 6.3 Otetaan talteen uudelleen simuloidut tulokset ja nimetn 
       laskennassa tarvittavat tulo- ja verotiedot uudelleen */

DATA OUTPUT.&TULOSNIMI_KOKO;
SET OUTPUT.&TULOSNIMI_KOKO;
VEROT2 = VEROTYHT;
KTU2 = KAYT_TULO;
KEEP VEROT2 KTU2;
RUN;

/* 6.4 Lasketaan marginaaliveroaste ja efektiivinen marginaaliveroaste */

DATA OUTPUT.&TULOSNIMI_KOKO;
MERGE OUTPUT.&TULOSNIMI_KOKO  TEMP.KOKO_ESIM_MARGVERO ;
MARGIVERO = 100 * SUM(VEROT2, -VEROT) / (12 * KOKO_ASKEL); /* HUOM! KOKO-mallissa palkka on kuukausitasolla, jonka vuoksi mys askel on kerrottava 12:sta */
EFMARGIVERO = 100 * (1 - (SUM(KTU2, -KTU) / KOKO_ASKEL));

DROP VEROT VEROT2 KTU2 KTU;

RUN;

%MEND Koko_Simuloi_MargVero;

/* 7. Kootaan ja tulostetaan tulokset */

%MACRO Koko_Tulokset;

/* 7.1 Laitetaan muuttujat oikeaan jrjestykseen */

DATA OUTPUT.&TULOSNIMI_KOKO;
	RETAIN KOKO_VUOSI KOKO_KUUK KOKO_PUOLISO KOKO_LAPSIA_ALLE3 KOKO_LAPSIA_3_6 KOKO_LAPSIA_7_9 KOKO_LAPSIA_10_15 KOKO_LAPSIA_16 KOKO_LAPSIA_17 KOKO_LAPSIAYHT
	KOKO_IKA KOKO_IKA_PUOL 
	KOKO_YAKRYHMA KOKO_YALISAKRYHMA KOKO_YALAMMRYHMA KOKO_EAKRYHMA KOKO_EALAMMRYHMA	KOKO_KELRYHMA KOKO_KUNNVERO KOKO_KIRKVERO
	KOKO_VALMVUOSI KOKO_PINTALA KOKO_OMISTUS KOKO_OMAKOTI
	KOKO_VUOKRA_VASTIKE KOKO_VESI KOKO_ASKOROT KOKO_TILANNE KOKO_TILANNE_PUOL KOKO_KOROTUS KOKO_MTURVA KOKO_AKTIIVI KOKO_TTPAIVAT KOKO_EPIDEMKORVL KOKO_PALKKA KOKO_TULONHANKKULUT KOKO_AYMAKSUT  
	KOKO_TYOMATKAKULUT KOKO_EDPALKKA KOKO_ELAKE KOKO_ASKEL KOKO_PALKKA_PUOL KOKO_TULONHANKKULUT_PUOL KOKO_AYMAKSUT_PUOL KOKO_TYOMATKAKULUT_PUOL KOKO_EDPALKKA_PUOL
	KOKO_ELAKE_PUOL INF TYOTPR SVHANKVAH SAIRPR KOTIHTULOT KOTIHTU OPINTUKI_TUKIAIKA OPRAHA OPIR OPLAINA OPLAI ASUMLISA ASLIS KANSEL TAKUUEL LESKENELAK LAPSENELAK ELAKYHT LAPSIKORO
	TYOEL TYOTMAKSU SVPRMAKSU PALKVAK HANKVAH ANSIOTULO PUHDANSIOTULO ANS ELVAH VERTULO1 PER VERTULO2 KUNNANS OPRAHVAH KUNNOPRAHVAH KUNNELVAH KUNNVERTULO1 KUNNPER KUNNVERTULO2 KUNNVERO KIRKVERO SAIRVAKM KANSELM
	VALTELVAH VALTVERTULO VALTVERO TYOTULVAH VALTVERO_B KUNNVERO_B SAIRVAKM_B KANSELM_B KIRKVERO_B VALTLAPS VALTVERO_C KUNNVERO_C SAIRVAKM_C KANSELM_C KIRKVERO_C
	VARSVEROTYHT VEROTYHT YLEVERO NETTOTULO VEROJENOSUUS TYOTPR_PUOL SVHANKVAH_PUOL SAIRPR_PUOL KOTIHTU_PUOL OPINTUKI_TUKIAIKA_PUOL OPRAHA_PUOL OPIR_PUOL OPLAINA_PUOL OPLAI_PUOL
	ASUMLISA_PUOL ASLIS_PUOL KANSEL_PUOL TAKUUEL_PUOL LESKENELAK_PUOL ELAKYHT_PUOL LAPSIKORO_PUOL TYOEL_PUOL TYOTMAKSU_PUOL SVPRMAKSU_PUOL PALKVAK_PUOL HANKVAH_PUOL
	ANSIOTULO_PUOL PUHDANSIOTULO_PUOL ANS_PUOL ELVAH_PUOL VERTULO1_PUOL PER_PUOL VERTULO2_PUOL KUNNANS_PUOL OPRAHVAH_PUOL KUNNOPRAHVAH_PUOL KUNNELVAH_PUOL KUNNVERTULO1_PUOL KUNNPER_PUOL KUNNVERTULO2_PUOL KUNNVERO_PUOL KIRKVERO_PUOL
	SAIRVAKM_PUOL KANSELM_PUOL VALTELVAH_PUOL VALTVERTULO_PUOL VALTVERO_PUOL TYOTULVAH_PUOL VALTVERO_B_PUOL KUNNVERO_B_PUOL SAIRVAKM_B_PUOL KANSELM_B_PUOL
	KIRKVERO_B_PUOL VALTLAPS_PUOL VALTVERO_C_PUOL KUNNVERO_C_PUOL SAIRVAKM_C_PUOL KANSELM_C_PUOL KIRKVERO_C_PUOL VARSVEROTYHT_PUOL VEROTYHT_PUOL YLEVERO_PUOL
	NETTOTULO_PUOL VEROJENOSUUS_PUOL LAPSLIS ELATTUKI ASUMLISAYHT OIKELASUM ELASUMTUKI ASUMTULO PERUSOM ASUMTUKI PHTULO PHMAKSUT NETTOTYOTULO MUUSEKALTULO MUUNETTOTULO
	TOIMTUKI EPIDEMKORV VAHKOROT ALIJHYV KOTITVARSVEROT KOTITVEROTYHT KOTITNETTOTULO KAYT_TULO MARGIVERO EFMARGIVERO; 
	SET OUTPUT.&TULOSNIMI_KOKO;
RUN;

/* 7.2 Mritelln muuttujille selkokieliset selitteet */

PROC DATASETS LIB=OUTPUT NOPRINT;
	MODIFY &TULOSNIMI_KOKO;
	LABEL 
	KOKO_VUOSI = 'Lainsdntvuosi'
	KOKO_KUUK = 'Lainsdntkuukausi'
	KOKO_PUOLISO = 'Onko puolisoa, (0/1)'
	KOKO_LAPSIA_ALLE3 = 'Alle 3-vuotiaiden lasten lukumr'
	KOKO_LAPSIA_3_6 = '3-6-vuotiaiden lasten lukumr'
	KOKO_LAPSIA_7_9 = '7-9-vuotiaiden lasten lukumr'
	KOKO_LAPSIA_10_15 = '10-15-vuotiaiden lasten lukumr'
	KOKO_LAPSIA_16 = '16-vuotiaiden lasten lukumr'
	KOKO_LAPSIA_17 = '17-vuotiaiden lasten lukumr'
	KOKO_IKA = 'Henkiln ik'
	KOKO_IKA_PUOL = 'Puolison ik'
	KOKO_YAKRYHMA = 'Yleisen asumistuen kuntaryhm, 1-4'
	KOKO_YALISAKRYHMA = 'Yleisen asumistuen liskustannusryhm, 0-2'
	KOKO_YALAMMRYHMA = 'Yleisen asumistuen lmmitysryhm, 1-3'
	KOKO_EAKRYHMA = 'Elkkeensaajan asumistuen kuntaryhm, 1-4'
	KOKO_EALAMMRYHMA = 'Elkkeensaajan asumistuen lmmitysryhm, 1-3'
	KOKO_KELRYHMA = 'Kunnan kalleusluokka, 1/2'
	KOKO_KUNNVERO = 'Kunnallisveroprosentti (999 = keskim. veropros.), %'
	KOKO_KIRKVERO = 'Kirkollisveroprosentti (999 = keskim. veropros.), %'
	KOKO_VALMVUOSI = 'Asunnon valmistumis- tai perusparannusvuosi'
	KOKO_PINTALA = 'Asunnon pinta-ala, (m2)'
	KOKO_OMISTUS = 'Omistusasunto, (0/1)'
	KOKO_OMAKOTI = 'Omakotitalo, (0/1)'
	KOKO_VUOKRA_VASTIKE = 'Vuokra tai yhtivastike, (e/kk)'
	KOKO_VESI = 'Vesimaksu, (e/kk)'
	KOKO_ASKOROT = 'Asuntolainan korot, (e/kk)'
	KOKO_TILANNE = 'Henkiln status'
	KOKO_TILANNE_PUOL = 'Puolison status'
	KOKO_KOROTUS = 'Tyttmyysturvan korotusosa, (0/1)'
	KOKO_MTURVA = 'Tyttmyysturvan muutosturvalis / tyllistmisohjelmalis, (0/1)'
	KOKO_AKTIIVI = 'Tyttmyysturvan aktiivimallin leikkuri, (0/1)'
	KOKO_EPIDEMKORVL = 'Lasketaanko mahdollinen epidemiakorvaus, (0/1)' 
	KOKO_PALKKA = 'Tytulo, (e/kk)'
	KOKO_ASKEL = 'Tuloaskel, jolla tuloa korotetaan marginaaliveroastetta laskettaessa, (e/kk)'
	KOKO_EDPALKKA = 'Pivrahan perusteena oleva palkka, (e/kk)'
	KOKO_TULONHANKKULUT = 'Tulonhankkimiskulut, (e/kk)'
	KOKO_AYMAKSUT = 'Ay-jsenmaksut, (e/kk)'
	KOKO_TYOMATKAKULUT = 'Tymatkakulut, (e/kk)'
	KOKO_ELAKE = 'Tyelke, (e/kk)'

	KOKO_PALKKA_PUOL = 'Puolison tytulo, (e/kk)'
	KOKO_EDPALKKA_PUOL = 'Puolison pivrahan perusteena oleva palkka, (e/kk)'
	KOKO_TULONHANKKULUT_PUOL = 'Puolison tulonhankkimiskulut, (e/kk)'
	KOKO_AYMAKSUT_PUOL = 'Puoliston ay-jsenmaksut, (e/kk)'
	KOKO_TYOMATKAKULUT_PUOL = 'Puolison tymatkakulut, (e/kk)'
	KOKO_ELAKE_PUOL = 'Puolison tyelke, (e/kk)'

	INF = 'Inflaatiokorjauksessa kytettv kerroin'

	TYOTPR = 'Tyttmyyspivrahat, (e/kk)'
	TYOTPR_PUOL = 'Puoliso: Tyttmyyspivrahat, (e/kk)'
	SAIRPR = 'Sairausvakuutuksen pivrahat tai vanhempainpivrahat, (e/kk)'
	SVHANKVAH = 'Sairausvakuutuksen pivrahojen tai vanhempainpivrahojen laskennassa vhennetyt tulonhankkimiskulut, (e/v)'
	SAIRPR_PUOL = 'Puoliso: Sairausvakuutuksen pivrahat tai vanhempainpivrahat, (e/kk)'
	SVHANKVAH_PUOL = 'Puoliso: Sairausvakuutuksen pivrahojen tai vanhempainpivrahojen laskennassa kytetyt tulonhankkimiskulut, (e/v)'
	KOTIHTULOT = 'Kotihoidon tuen perusteena olevat kotitalouden tulot, (e/kk)' 
	KOTIHTU = 'Kotihoidon tuki, (e/kk)'
	KOTIHTU_PUOL = 'Puoliso: Kotihoidon tuki, (e/kk)'
	OPINTUKI_TUKIAIKA = 'Opintotuen laskennassa kytetyt tukikuukaudet vuodessa'
	OPINTUKI_TUKIAIKA_PUOL = 'Puoliso: Opintotuen laskennassa kytetyt tukikuukaudet vuodessa'
	OPRAHA = 'Opintoraha, (e/kk)'
	OPIR = 'Opintoraha, (e/tukikk)'
	OPRAHA_PUOL = 'Puoliso: Opintoraha, (e/kk)'
	OPIR_PUOL = 'Puoliso: Opintoraha, (e/tukikk)'
	OPLAINA = 'Opintolaina, (e/kk)'
	OPLAI = 'Opintolaina, (e/tukikk)'
	OPLAINA_PUOL = 'Puoliso: Opintolaina, (e/kk)'
	OPLAI_PUOL = 'Puoliso: Opintolaina, (e/tukikk)'
	ASUMLISA = 'Opintotuen asumislis, (e/kk)'
	ASLIS = 'Opintotuen asumislis, (e/tukikk)'
	ASUMLISA_PUOL = 'Puoliso: Opintotuen asumislis, (e/kk)'
	ASLIS_PUOL = 'Puoliso: Opintotuen asumislis, (e/tukikk)'
	KANSEL = 'Kansanelke, (e/kk)'
	KANSEL_PUOL = 'Puoliso: Kansanelke, (e/kk)'
	TAKUUEL = 'Takuuelke, (e/kk)'
	TAKUUEL_PUOL = 'Puoliso: Takuuelke, (e/kk)'
	ELAKYHT = 'Ty-, kansan-, takuu- ja leskenelke yhteens, (e/kk)'
	ELAKYHT_PUOL = 'Puoliso: Ty-, kansan-, takuu- ja leskenelke yhteens, (e/kk)'
	LAPSIKORO = 'Elkkeensaajan lapsikorotukset, (e/kk)'
	LAPSIKORO_PUOL = 'Puoliso: Elkkeensaajan lapsikorotukset, (e/kk)'

	LAPSENELAK = 'Lapsenelke, (e/kk)'
	LESKENELAK = 'Leskenelke, (e/kk)'
	LESKENELAK_PUOL = 'Puoliso: Leskenelke, (e/kk)'
	TYOEL = 'Palkansaajan tyelkemaksu, (e/v)'
	TYOEL_PUOL = 'Puoliso: Palkansaajan tyelkemaksu, (e/v)'
	TYOTMAKSU = 'Palkansaajan tyttmyysvakuutusmaksu, (e/v)'
	TYOTMAKSU_PUOL = 'Puoliso: Palkansaajan tyttmyysvakuutusmaksu, (e/v)'
	SVPRMAKSU = 'Sairausvakuutuksen pivrahamaksu, (e/v)'
	SVPRMAKSU_PUOL = 'Puoliso: Sairausvakuutuksen pivrahamaksu, (e/v)'
	PALKVAK = 'Palkansaajan elke-, tyttmyysvakuutusmaksu ja sairausvakuutuksen pivrahamaksu yhteens, (e/v)'
	PALKVAK_PUOL = 'Puoliso: Palkansaajan elke-, tyttmyysvakuutusmaksu ja sairausvakuutuksen pivrahamaksu yhteens, (e/v)'
	HANKVAH = 'Tulonhankkimisvhennys, (e/v)'
	HANKVAH_PUOL = 'Puoliso: Tulonhankkimisvhennys, (e/v)'
	ANSIOTULO = 'Ansiotulot yhteens, (e/v)'
	ANSIOTULO_PUOL = 'Puoliso: Ansiotulot yhteens, (e/v)'
	PUHDANSIOTULO = 'Puhdas ansiotulo, (e/v)'
	PUHDANSIOTULO_PUOL = 'Puoliso: Puhdas ansiotulo, (e/v)'
	ANS = 'Ansiotulovhennys (2023-), (e/v)'
	ANS_PUOL = 'Puoliso: Ansiotulovhennys (2023-), (e/v)'
	KUNNANS = 'Kunnallisverotuksen ansiotulovhennys (-2022), (e/v)'
	KUNNANS_PUOL = 'Puoliso: Kunnallisverotuksen ansiotulovhennys (-2022), (e/v)'
	OPRAHVAH = 'Opintorahavhennys, (e/v), (2023-)'
	OPRAHVAH_PUOL = 'Puoliso: Opintorahavhennys, (e/v), (2023-)'
	KUNNOPRAHVAH = 'Kunnallisverotuksen opintorahavhennys (e/v), (-2022)'
	KUNNOPRAHVAH_PUOL = 'Puoliso: Kunnallisverotuksen opintorahavhennys (e/v), (-2022)'
	ELVAH = 'Elketulovhennys (2023-), (e/v)'
	ELVAH_PUOL = 'Puoliso: Elketulovhennys (2023-), (e/v)'
	KUNNELVAH = 'Kunnallisverotuksen elketulovhennys (-2022), (e/v)'
	KUNNELVAH_PUOL = 'Puoliso: Kunnallisverotuksen elketulovhennys (-2022), (e/v)'
	VERTULO1 = 'Verotettava tulo ennen perusvhennyst (2023-), (e/v)'
	VERTULO1_PUOL = 'Puoliso: Verotettava tulo ennen perusvhennyst (2023-), (e/v)'
	KUNNVERTULO1 = 'Kunnalliverotuksessa verotettava tulo ennen perusvhennyst (-2022), (e/v)'
	KUNNVERTULO1_PUOL = 'Puoliso: Kunnalliverotuksessa verotettava tulo ennen perusvhennyst (-2022), (e/v)'
	PER = 'Perusvhennys (2023-), (e/v)'
	PER_PUOL = 'Puoliso: Perusvhennys (2023-), (e/v)'
	KUNNPER = 'Kunnallisverotuksen perusvhennys (-2022), (e/v)'
	KUNNPER_PUOL = 'Puoliso: Kunnallisverotuksen perusvhennys (-2022), (e/v)'
	VERTULO2 = 'Verotettava tulo (2023-), (e/v)'
	VERTULO2_PUOL = 'Puoliso: Verotettava tulo (2023-), (e/v)'
	KUNNVERTULO2 = 'Kunnallisverotuksessa verotettava tulo, (e/v)'
	KUNNVERTULO2_PUOL = 'Puoliso: Kunnallisverotuksessa verotettava tulo, (e/v)'
	KUNNVERO = 'Kunnallisvero ennen verosta tehtvi vhennyksi, (e/v)'
	KUNNVERO_PUOL = 'Puoliso: Kunnallisvero ennen verosta tehtvi vhennyksi, (e/v)' 
	KUNNVERO_B = 'Kunnallisvero tytulovhennyksen jlkeen, (e/v)'
	KUNNVERO_B_PUOL = 'Puoliso: Kunnallisvero tytulovhennyksen jlkeen, (e/v)' 
	KUNNVERO_C = 'Kunnallisvero lapsivhennyksen jlkeen, (e/v)'
	KUNNVERO_C_PUOL = 'Puoliso: Kunnallisvero lapsivhennyksen jlkeen, (e/v)' 
	KIRKVERO = 'Kirkollisvero ennen verosta tehtvi vhennyksi, (e/v)'
	KIRKVERO_PUOL = 'Puoliso: Kirkollisvero ennen verosta tehtvi vhennyksi, (e/v)'
	KIRKVERO_B = 'Kirkollisvero tytulovhennyksen jlkeen, (e/v)'
	KIRKVERO_B_PUOL = 'Puoliso: Kirkollisvero tytulovhennyksen jlkeen, (e/v)'
	KIRKVERO_C = 'Kirkollisvero lapsivhennyksen jlkeen, (e/v)'
	KIRKVERO_C_PUOL = 'Puoliso: Kirkollisvero lapsivhennyksen jlkeen, (e/v)'
	SAIRVAKM = 'Sairaanhoitomaksu/sairausvakuutusmaksu ennen verosta tehtvi vhennyksi, (e/v)'
	SAIRVAKM_PUOL = 'Puoliso: Sairaanhoitomaksu/sairausvakuutusmaksu ennen verosta tehtvi vhennyksi, (e/v)'
	SAIRVAKM_B = 'Sairaanhoitomaksu/sairausvakuutusmaksu ansio/tytulovhennyksen jlkeen, (e/v)'
	SAIRVAKM_B_PUOL = 'Puoliso: Sairaanhoitomaksu/sairausvakuutusmaksu tytulovhennyksen jlkeen, (e/v)'
	SAIRVAKM_C = 'Sairaanhoitomaksu/sairausvakuutusmaksu lapsivhennyksen jlkeen, (e/v)'
	SAIRVAKM_C_PUOL = 'Puoliso: Sairaanhoitomaksu/sairausvakuutusmaksu lapsivhennyksen jlkeen, (e/v)'
	KANSELM = 'Kansanelkevakuutusmaksu ennen verosta tehtvi vhennyksi, (e/v)'
	KANSELM_PUOL = 'Puoliso: Kansanelkevakuutusmaksu ennen verosta tehtvi vhennyksi, (e/v)'
	KANSELM_B = 'Kansanelkevakuutusmaksu tytulovhennyksen jlkeen, (e/v)'
	KANSELM_B_PUOL = 'Puoliso: Kansanelkevakuutusmaksu ansio/tytulovhennyksen jlkeen, (e/v)'
	KANSELM_C = 'Kansanelkevakuutusmaksu lapsivhennyksen jlkeen, (e/v)'
	KANSELM_C_PUOL = 'Puoliso: Kansanelkevakuutusmaksu lapsivhennyksen jlkeen, (e/v)'
	VALTELVAH = 'Valtionverotuksen elketulovhennys (-2022), (e/v)'
	VALTELVAH_PUOL = 'Puoliso: Valtionverotuksen elketulovhennys (-2022), (e/v)'
	VALTVERTULO = 'Valtionverotuksessa verotettava tulo, (e/v)'
	VALTVERTULO_PUOL = 'Puoliso: Valtionverotuksessa verotettava tulo, (e/v)'
	VALTVERO = 'Valtion tulovero ennen verosta tehtvi vhennyksi, (e/v)'
	VALTVERO_PUOL = 'Puoliso: Valtion tulovero ennen verosta tehtvi vhennyksi, (e/v)'
	VALTVERO_B = 'Valtion tulovero tytulovhennyksen jlkeen, (e/v)'
	VALTVERO_B_PUOL = 'Puoliso: Valtion tulovero tytulovhennyksen jlkeen, (e/v)'
	VALTVERO_C = 'Valtion tulovero lapsivhennyksen jlkeen, (e/v)'
	VALTVERO_C_PUOL = 'Puoliso: Valtion tulovero lapsivhennyksen jlkeen, (e/v)'
	TYOTULVAH = 'Tytulovhennys, (e/v)'
	TYOTULVAH_PUOL = 'Puoliso: Tytulovhennys, (e/v)'
	VARSVEROTYHT = 'Verot yhteens lapsivhennyksen jlkeen, (e/v)'
	VARSVEROTYHT_PUOL = 'Puoliso: Verot yhteens lapsivhennyksen jlkeen, (e/v)'
	VALTLAPS = 'Lapsivhennys, (e/v)'
	VALTLAPS_PUOL = 'Puoliso: Lapsivhennys, (e/v)'
	YLEVERO = 'YLE-vero, (e/v)'
	YLEVERO_PUOL = 'Puoliso: YLE-vero, (e/v)'
	VEROTYHT = 'Verot ja veroluontoiset maksut yhteens lapsivhennyksen jlkeen, (e/v)'
	VEROTYHT_PUOL = 'Puoliso: Verot ja veroluontoiset maksut yhteens lapsivhennyksen jlkeen, (e/v)'
	NETTOTULO = 'Nettotulo lapsivhennyksen jlkeen, (e/kk)'
	NETTOTULO_PUOL = 'Puoliso: Nettotulo lapsivhennyksen jlkeen, (e/kk)'
	VEROJENOSUUS = 'Verojen ja veroluontoisten maksujen osuus tuloista lapsivhennyksen jlkeen, (%)'
	VEROJENOSUUS_PUOL = 'Puoliso: Verojen ja veroluontoisten maksujen osuus tuloista lapsivhennyksen jlkeen, (%)'

	LAPSLIS = 'Kotitalous: Lapsilist, (e/kk)'
	KOKO_LAPSIAYHT = 'Lasten (alle 18-v.) lukumr kotitaloudessa'
	ELATTUKI = 'Kotitalous: Elatustuki, (e/kk)'
	VAHKOROT = 'Kotitalous: Vhennyskelpoiset korot, (e/v)'
	ALIJHYV = 'Kotitalous: Alijmhyvitys, (e/v)'
	KOTITVARSVEROT = 'Kotitalous: Verot yhteens alijmhyvityksen jlkeen, (e/v)'
	KOTITVEROTYHT = 'Kotitalous: Verot ja veroluontoiset maksut yhteens alijmhyvityksen jlkeen, (e/v)'
	KOTITNETTOTULO = 'Kotitalous: Nettotulo alijmhyvityksen jlkeen, (e/kk)'
	ASUMLISAYHT = 'Kotitalous: Opintotuen asumislis, (e/kk)'
	OIKELASUM = 'Kotitalous: Oikeus elkkeensaajien asumistukeen, (0/1)' 
	ELASUMTUKI = 'Kotitalous: Elkkeensaajien asumistuki, (e/kk)'
	ASUMTULO = 'Kotitalous: Yleisen asumistuen perusomavastuun laskemista varten muodostettu tulo (ennen vuotta 2015), (e/kk)'
	PERUSOM = 'Kotitalous: Yleisen asumistuen perusomavastuu (ennen vuotta 2015), (e/kk)'
	ASUMTUKI = 'Kotitalous: Yleinen asumistuki, (e/kk)'
	PHTULO = 'Kotitalous: Pivhoitomaksujen perusteena oleva tulo, (e/kk)'
	PHMAKSUT = 'Kotitalous: Pivhoitomaksut, (e/kk)'
	NETTOTYOTULO = 'Kotitalous: Nettotytulo toimeentulotuessa, (e/kk)'
	MUUNETTOTULO = 'Kotitalous: Muu nettotulo toimeentulotuessa, (e/kk)'
	MUUSEKALTULO = 'Kotitalous: Muut verottomat tulot toimeentulotuessa, (e/kk)'
	TOIMTUKI = 'Kotitalous: Toimeentulotuki, (e/kk)'
	EPIDEMKORV = 'Kotitalous: Epidemiakorvaus, (e/kk)'
	KAYT_TULO = 'Kotitalous: Kytettviss oleva tulo, (e/kk)'

	MARGIVERO = 'Marginaaliveroaste, (%)'
	EFMARGIVERO = 'Kotitalous: Efektiivinen marginaaliveroaste, (%)'

	;
	%IF &EROTIN = 1 %THEN %DO;
		FORMAT _NUMERIC_ 1&DESIMAALIT..&DESIMAALIT;
		FORMAT INF MARGIVERO EFMARGIVERO VEROJENOSUUS 10.5;
	%END;

	%IF &EROTIN = 2 %THEN %DO;
		FORMAT _NUMERIC_ NUMx1&DESIMAALIT..&DESIMAALIT;
		FORMAT INF MARGIVERO EFMARGIVERO VEROJENOSUUS NUMx10.5;
	%END;

	/* Kokonaislukuina ne muuttujat, joissa ei haluta kytt desimaalierotinta */

	FORMAT KOKO_VUOSI KOKO_KUUK KOKO_PUOLISO KOKO_LAPSIA_ALLE3 KOKO_LAPSIA_3_6 KOKO_LAPSIA_7_9 KOKO_LAPSIA_10_15 
	KOKO_LAPSIA_16 KOKO_LAPSIA_17 KOKO_IKA KOKO_IKA_PUOL KOKO_YAKRYHMA KOKO_YALISAKRYHMA KOKO_YALAMMRYHMA
	KOKO_EAKRYHMA KOKO_EALAMMRYHMA KOKO_KELRYHMA KOKO_VALMVUOSI KOKO_OMISTUS KOKO_OMAKOTI KOKO_TILANNE
	KOKO_TILANNE_PUOL KOKO_KOROTUS KOKO_MTURVA KOKO_AKTIIVI KOKO_EPIDEMKORVL KOKO_LAPSIAYHT OIKELASUM OPINTUKI_TUKIAIKA OPINTUKI_TUKIAIKA_PUOL KOKO_TTPAIVAT 8.;

RUN;
QUIT;

/* Jos puolisoa ei ole mritelty, poistetaan laskennassa kutsumalla luodut puolison muuttujat */
%IF &MINIMI_KOKO_PUOLISO = 0 %THEN %DO;
	%PUT Ei mritelty puolisoa, joten poistetaan laskennassa kutsutut puolison sarakkeet.;
	/* Haetaan sarakkeiden nimet */
	PROC CONTENTS DATA=OUTPUT.&TULOSNIMI_KOKO OUT=TEMP.KOKO_ESIM_SARAK(KEEP=NAME) NOPRINT;
	RUN;

	/* Haetaan lista sarakkeista, jotka pttyvt _PUOL */
	PROC SQL NOPRINT;
	SELECT NAME INTO :PUDOTUS SEPARATED BY ' '
	FROM TEMP.KOKO_ESIM_SARAK
	WHERE UPCASE(NAME) LIKE '%^_PUOL' ESCAPE '^';
	QUIT;

	/* Poistetaan tulostiedostosta kaikki sarakkeet, jotka pttyvt _PUOL */
	DATA OUTPUT.&TULOSNIMI_KOKO;
	SET OUTPUT.&TULOSNIMI_KOKO;
	DROP &PUDOTUS;
	RUN;
%END;


/* Valitaan tulostettavat muuttujat */
DATA OUTPUT.&TULOSNIMI_KOKO;
SET OUTPUT.&TULOSNIMI_KOKO;
KEEP &VALITUT;
%IF &VUOSIKA NE 2 %THEN %DO;
	DROP KOKO_KUUK;
%END;

RUN;


* Tulosten printtaus ja vienti exceliin riippuen valinnasta; 
%EsimTulokset(&TULOSNIMI_KOKO, KOKO);

%MEND Koko_Tulokset;

/* 8. Suoritetaan kaikki vaiheet yhden pmakron sisll. */

%MACRO Koko_Simuloi_Esim;

/* Mritelln osamallien lainsdnnn parametrit lokaaleiksi makromuuttujiksi */

/* Muuttujat, joihin haetaan lista mallin kyttmist lakiparametreist */
%LOCAL SAIRVAK_PARAM SAIRVAK_MUUNNOS;

/* Haetaan SAIRVAK-mallin kyttmien lakiparametrien nimet */
%HaeLokaalit(SAIRVAK_PARAM, SAIRVAK);
%HaeLaskettavatLokaalit(SAIRVAK_MUUNNOS, SAIRVAK);

%LOCAL &SAIRVAK_PARAM;

/* TTURVA-mallin parametrit */

%LOCAL TTURVA_PARAM TTURVA_MUUNNOS;

%HaeLokaalit(TTURVA_PARAM, TTURVA);
%HaeLaskettavatLokaalit(TTURVA_MUUNNOS, TTURVA);

/* Luodaan tyhjt lokaalit muuttujat lakiparametien hakua varten */
%LOCAL &TTURVA_PARAM;

/* KANSEL-mallin parametrit */

%LOCAL KANSEL_PARAM KANSEL_MUUNNOS;

%HaeLokaalit(KANSEL_PARAM, KANSEL);
%HaeLaskettavatLokaalit(KANSEL_MUUNNOS, KANSEL);

%LOCAL &KANSEL_PARAM;

/* KOTIHTUKI-mallin parametrit */
%LOCAL KOTIHTUKI_PARAM KOTIHTUKI_MUUNNOS;

%HaeLokaalit(KOTIHTUKI_PARAM, KOTIHTUKI);
%HaeLaskettavatLokaalit(KOTIHTUKI_MUUNNOS, KOTIHTUKI);

%LOCAL &KOTIHTUKI_PARAM;

/* PHOITO-mallin parametrit*/
%LOCAL PHOITO_PARAM PHOITO_MUUNNOS;

%HaeLokaalit(PHOITO_PARAM, PHOITO);
%HaeLaskettavatLokaalit(PHOITO_MUUNNOS, PHOITO);

%LOCAL &PHOITO_PARAM;

/* OPINTUKI-mallin parametrit */

%LOCAL OPINTUKI_PARAM OPINTUKI_MUUNNOS;

%HaeLokaalit(OPINTUKI_PARAM, OPINTUKI);
%HaeLaskettavatLokaalit(OPINTUKI_MUUNNOS, OPINTUKI);

%LOCAL &OPINTUKI_PARAM;

/* VERO-mallin parametrit */

%LOCAL VERO_PARAM VERO_MUUNNOS VERO2_PARAM VERO2_MUUNNOS VERO_JOHDETUT;

/* Haetaan mallin kyttmien lakiparametrien nimet */
%HaeLokaalit(VERO_PARAM, VERO);
%HaeLaskettavatLokaalit(VERO_MUUNNOS, VERO);

/* Haetaan johdettavien muuttujien nimet */
%HaeLaskettavatLokaalit(VERO_JOHDETUT, VERO, indikaattori='j');

/* Varallisuusveroon liittyvt parametrit (VERO-malli) */

/* Haetaan varallisuusveron kyttmien lakiparametrien nimet */
%HaeLokaalit(VERO2_PARAM, VERO_VARALL);
%HaeLaskettavatLokaalit(VERO2_MUUNNOS, VERO_VARALL, indikaattori='z');

/* Luodaan tyhjt lokaalit muuttujat lakiparametien hakua varten */
%LOCAL &VERO_PARAM &VERO2_PARAM &VERO_JOHDETUT;

/* KIVERO-mallin parametrit */
%LOCAL KIVERO_PARAM KIVERO_MUUNNOS;

%HaeLokaalit(KIVERO_PARAM, KIVERO);
%HaeLaskettavatLokaalit(KIVERO_MUUNNOS, KIVERO);

%LOCAL &KIVERO_PARAM;

/* LLISA-mallin parametrit */
%LOCAL LLISA_PARAM LLISA_MUUNNOS;
%HaeLokaalit(LLISA_PARAM, LLISA);
%HaeLaskettavatLokaalit(LLISA_MUUNNOS, LLISA);

%LOCAL &LLISA_PARAM;

/* ELASUMTUKI-malli parametrit */
%LOCAL ELASUMTUKI_PARAM ELASUMTUKI_MUUNNOS;

%HaeLokaalit(ELASUMTUKI_PARAM, ELASUMTUKI);
%HaeLaskettavatLokaalit(ELASUMTUKI_MUUNNOS, ELASUMTUKI);

%LOCAL &ELASUMTUKI_PARAM;

/* ASUMTUKI-mallin parametrit */
%LOCAL ASUMTUKI_PARAM ASUMTUKI_MUUNNOS;

%HaeLokaalit(ASUMTUKI_PARAM, ASUMTUKI);
%HaeLaskettavatLokaalit(ASUMTUKI_MUUNNOS, ASUMTUKI);

%LOCAL &ASUMTUKI_PARAM;

/* TOIMTUKI-mallin parametrit */
%LOCAL TOIMTUKI_PARAM TOIMTUKI_MUUNNOS;

%HaeLokaalit(TOIMTUKI_PARAM, TOIMTUKI);
%HaeLaskettavatLokaalit(TOIMTUKI_MUUNNOS, TOIMTUKI);

%LOCAL &TOIMTUKI_PARAM;

/* Epidemiaetuuksien parametrit */
%LOCAL EPIDEM_PARAM EPIDEM_MUUNNOS;

%HaeLokaalit(EPIDEM_PARAM, EPIDEM);
%HaeLaskettavatLokaalit(EPIDEM_MUUNNOS, EPIDEM);

%LOCAL &EPIDEM_PARAM; 

/* Yksiltason laskenta */
%KOKO_LASKENTA(0);
%KOKO_LASKENTA(1);

/* Haetaan vuokranormiparametrit 2011 tasolla, jotta ert taulukot syntyvt
(ongelma, mikli asumistukia ei ole ajettu mallilla aiemmin */
%HaeParam_VuokraNormit(2011);

/* Kotitaloustason laskenta */
%KOKO_LASKENTA_KOTIT;

/* Lasketaan marginaaliveroasteet */
%Koko_Simuloi_MargVero;

/* Tulostetaan tulokset */
%Koko_Tulokset;

%MEND Koko_Simuloi_Esim;

%Koko_Simuloi_Esim;
