/************************************************************ 
* Kuvaus: Lapsilisn lainsdnt makroina					*
************************************************************/


/* 1. SISLLYS */

/* Tiedosto sislt seuraavat makrot */

/*
2. LLisaKS = Lapsilis eri-ikisten lasten lukumrn mukaan kuukausitasolla
3. LLisaVS = Lapsilis eri-ikisten lasten lukumrn mukaan kuukausitasolla vuosikeskiarvona
4. AitAvustKS = itiysavustus
5. AitAvustVS = itiysavustus vuosikeskiarvona
6. ElatTukiKS = Elatustuki kuukausitasolla
7. ElatTukiVS = Elatustuki kuukausitasolla vuosikeskiarvona
8. LLisaK1S = Lapsilis yhdest lapsesta jrjestysluvun mukaan kuukausitasolla
9. LLisaV1S = Lapsilis yhdest lapsesta jrjestysluvun mukaan kuukausitasolla vuosikeskiarvona
10. AitLkm = Makro, jolla mritelln itiysavustukseen oikeuttavien lasten lukumr vuodesta 2003 lhtien
*/


/* 2. Makro laskee lapsilisn eri-ikisten lasten lukumrn mukaan kuukausitasolla */

* Makron parametrit:
    tulos: Makron tulosmuuttuja, lapsiliskuukaudessa, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
	puoliso: Onko henkilll puoliso (0/1)
	lapsiaalle_3_v: Alle 3-vuotiaiden lasten lukumr 
	lapsia_3_15_v: 3-15-vuotiaiden lasten lukumr
	lapsia_16_v: 16-vuotiaiden lasten lukumr;


%MACRO LLisaKS(tulos, mvuosi, mkuuk, minf, puoliso, lapsiaAlle_3_v, lapsia_3_15_v, lapsia_16_v)/
DES = 'LLISA: Lapsilis eri-ikisten lasten lukumrn mukaan kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &LLISA_PARAM, PARAM.&PLLISA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &LLISA_MUUNNOS, &minf);

%LuoKuuID(kuuid, &mvuosi, &mkuuk);

IF not(&puoliso = 0) THEN yksinhuoltaja = 0; * Ei yksinhuoltaja;
ELSE yksinhuoltaja = 1;

*Lapsilisn ikrajan muutos kuukaudesta 1994/1 lhtien;
IF kuuid >= MDY(1, 1, 1994) THEN
lapsia = SUM(&lapsiaAlle_3_v, &lapsia_3_15_v, &lapsia_16_v);
ELSE lapsia = SUM(&lapsiaAlle_3_v, &lapsia_3_15_v);

SELECT (lapsia);
	WHEN(0) temp = 0;
	WHEN(1) temp = &Lapsi1;
	WHEN(2) temp = SUM(&Lapsi1, &Lapsi2);
	WHEN(3) temp = SUM(&Lapsi1, &Lapsi2, &Lapsi3);
	WHEN(4) temp = SUM(&Lapsi1, &Lapsi2, &Lapsi3, &Lapsi4);
	WHEN(5) temp = SUM(&Lapsi1, &Lapsi2, &Lapsi3, &Lapsi4, &Lapsi5);
	OTHERWISE temp = SUM(&Lapsi1, &Lapsi2, &Lapsi3, &Lapsi4, &Lapsi5, ((lapsia-5) * &Lapsi5));
END;
temp = SUM(temp, (&lapsiaAlle_3_v * &alle3v), (lapsia * &yksHuolt * yksinhuoltaja));

*Jatkettu lapsilis kuukausina 1986/10 - 1993/12;
IF kuuid >= MDY(10, 1, 1986) AND kuuid <= MDY(12, 1, 1993) THEN
	temp = SUM(temp, (&lapsia_16_v * &lapsi1));

&tulos = temp; 
DROP kuuid yksinhuoltaja lapsia temp;
%MEND LLisaKS;


/* 3. Makro laskee lapsilisn eri-ikisten lasten lukumrn mukaan kuukausitasolla vuosikeskiarvona */

* Makron parametrit:
    tulos: Makron tulosmuuttuja, lapsilis, e/kk (vuosikeskiarvo) 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
	puoliso: Onko henkilll puoliso (0/1)
	lapsiaAlle_3_v: Alle 3-vuotiaiden lasten lukumr 
	lapsia_3_15_v: 3-15-vuotiaiden lasten lukumr
	lapsia_16_v: 16-vuotiaiden lasten lukumr;

%MACRO LLisaVS(tulos, mvuosi, minf, puoliso, lapsiaAlle_3_v, lapsia_3_15_v, lapsia_16_v)/
DES = 'LLISA: Lapsilis eri-ikisten lasten lukumrn mukaan kuukausitasolla vuosikeskiarvona';

raha = 0;

%DO i = 1 %TO 12;
	%LLisaKS(temp, &mvuosi, &i, &minf, &puoliso, &lapsiaAlle_3_v, &lapsia_3_15_v, &lapsia_16_v);
  	raha = SUM(raha, temp);
%END;
&tulos = raha / 12;
DROP raha temp;
%MEND LLisaVS; 


/* 4. Makro laskee itiysavustuksen */

* Makron parametrit:
    tulos: Makron tulosmuuttuja, itiysavustus, e
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
	syntlapsia: Syntyneiden lasten lukumr;

%MACRO AitAvustKS(tulos, mvuosi, mkuuk, minf, syntlapsia)/
DES = 'LLISA: itiysavustus';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &LLISA_PARAM, PARAM.&PLLISA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &LLISA_MUUNNOS, &minf);

%LuoKuuID(kuuid, &mvuosi, &mkuuk);

/* itiysavustuksen suuruus on mritelty kutakin syntynytt tai adoptioon otettua lasta kohden.
Valtioneuvoston asetuksella 30.1.2003/67 tt periaatetta muutettiin 1.3.2003 lhtien siten, ett itiysavustus
suoritetaan lapsiluvun mukaan korotettuna, jos samanaikaisesti syntyy tai ottolapseksi otetaan useampi
lapsi. Toisesta lapsesta itiysavustus suoritetaan kaksinkertaisena, kolmannesta kolminkertaisena jne. */

temp = 0;

IF kuuid >= MDY(3, 1, 2003) THEN DO;
	DO j = 1 TO &syntlapsia; 
	temp = SUM(temp, (j * &AitAv));
	END;
END;

IF kuuid < MDY(3, 1, 2003) THEN temp = &syntlapsia * &AitAv;

&tulos = temp; 
DROP temp kuuid j;
%MEND AitAvustKS;


/* 5. Makro laskee itiysavustuksen vuosikeskiarvona */

* Makron parametrit:
    tulos: Makron tulosmuuttuja, itiysavustus, e 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
	syntlapsia: Syntyneiden lasten lukumr;

%MACRO AitAvustVS(tulos, mvuosi, minf, syntlapsia)/
DES = 'LLISA: itiysavustus vuosikeskiarvona';

raha = 0;
%DO i = 1 %TO 12;
	%AitAvustKS(temp, &mvuosi, &i, &minf, &syntlapsia);
  	raha = SUM(raha, temp);
%END;

&tulos = raha / 12;
DROP raha temp;
%MEND AitAvustVS;


/* 6. Makro laskee elatustuen kuukausitasolla */

* Makron parametrit:
    tulos: Makron tulosmuuttuja, elatustuki, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
	puoliso: Onko henkilll puoliso (0/1)
	lapsia: Lasten lukumr;

%MACRO ElatTukiKS(tulos, mvuosi, mkuuk, minf, puoliso, lapsia)/
DES = 'LLISA: Elatustuki kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &LLISA_PARAM, PARAM.&PLLISA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &LLISA_MUUNNOS, &minf);

IF &puoliso = 1 THEN temp = &AlenElatTuki * &lapsia;
ELSE temp = &ElatTuki * &lapsia;

&tulos = temp;
DROP temp;
%MEND ElatTukiKS;


/* 7. Makro laskee elatustuen kuukausitasolla vuosikeskiarvona */

* Makron parametrit:
    tulos: Makron tulosmuuttuja, elatustuki, e/kk (vuosikeskiarvo) 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
	puoliso: Onko henkilll puoliso (0/1)
	lapsia: Lasten lukumr;

%MACRO ElatTukiVS(tulos, mvuosi, minf, puoliso, lapsia)/
DES = 'LLISA: Elatustuki kuukausitasolla vuosikeskiarvona';

raha = 0;

%DO i = 1 %TO 12;
	%ElatTukiKS(temp, &mvuosi, &i, &minf, &puoliso, &lapsia);
  	raha = SUM(raha, temp);
%END;

&tulos = raha / 12;
DROP raha temp;
%MEND ElatTukiVS;


/* 8. Makro laskee lapsilisn yhdest lapsesta jrjestysluvun mukaan kuukausitasolla */

* Makron parametrit:
	tulos: Makron tulosmuuttuja, lapsilis, e/kk
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn
	minf: Deflaattori euromristen parametrien kertomiseksi
	puoliso: Onko henkilll puoliso (0/1)
	alle_3_v: 1 = On alle 3-vuotias, 0 = Ei ole alle 3-v
	b16v: 1 = On 16-vuotias, 0 = Ei 16-vuotias
	jarj: Lapsen jrjestysluku;

%MACRO LLisaK1S(tulos, mvuosi, mkuuk, minf, puoliso, alle_3_v, b16v, jarj)/
DES = 'LLISA: Lapsilis yhdest lapsesta jrjestysluvun mukaan kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &LLISA_PARAM, PARAM.&PLLISA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &LLISA_MUUNNOS, &minf);

%LuoKuuID(kuuid, &mvuosi, &mkuuk);

*Jos jrjestysluku ei ole positiivinen, tulos = 0;
IF &jarj < 1 THEN temp = 0;

*Lapsi ei voi olla yht aikaa 16-vuotias ja alle 3-vuotias, laitetaan 16-vuotiaaksi. ;
IF &alle_3_v = 1 AND &b16v = 1 THEN DO; 
	alle_3_v = 0; 
END;
ELSE alle_3_v = &alle_3_v ;

SELECT (&jarj);
 	WHEN(0) lapsi = 0; * Tm listty laskentateknisist syist;
 	WHEN(1) lapsi = &Lapsi1;
	WHEN(2) lapsi = &Lapsi2;
	WHEN(3) lapsi = &Lapsi3;
	WHEN(4) lapsi = &Lapsi4;
	WHEN(5) lapsi = &Lapsi5;
	OTHERWISE lapsi = &Lapsi5; 
END;

*Jatkettu lapsilis kuukausina 1986/10 - 1993/12;
*Ei mitn lapsilis, jos alle 17-vuotias ennen 1986/10;
IF &b16v = 1 AND kuuid < MDY(10, 1, 1986)
THEN lapsi = 0 AND alle_3_v = 0; 
IF &b16v = 1 AND kuuid >= MDY(10, 1, 1986) AND kuuid <= MDY(12, 1, 1993)
THEN lapsi = &lapsi1;

IF &puoliso = 1 THEN YHuoltaja = 0;
IF &puoliso = 0 THEN YHuoltaja = 1;

*Otetaan huomioon yksinhuoltajalis;
IF lapsi = 0 THEN temp = 0;
ELSE temp = SUM(lapsi, (&yksHuolt * YHuoltaja));

*Alle 3-vuotiaan lis;
IF alle_3_v = 1 THEN temp = SUM(temp, &Alle3v);

&tulos = temp; 
DROP temp lapsi YHuoltaja kuuid alle_3_v;
%MEND LLisaK1S;


/* 9. Makro laskee lapsilisn yhdest lapsesta jrjestysluvun mukaan kuukausitasolla vuosikeskiarvona */

* Makron parametrit:
	tulos: Makron tulosmuuttuja, lapsilis, e/kk (vuosikeskiarvo) 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn
	minf: Deflaattori euromristen parametrien kertomiseksi
	puoliso: Onko henkilll puoliso (0/1)
	alle_3_v: 1 = On alle 3-vuotias, 0 = Ei ole alle 3-v
	b16v: 1 = On 16-vuotias, 0 = Ei 16-vuotias
	jarj: Lapsen jrjestysluku;

%MACRO LLisaV1S(tulos, mvuosi, minf, puoliso, alle_3_v, b16v, jarj)/
DES = 'LLISA: Lapsilis yhdest lapsesta jrjestysluvun mukaan kuukausitasolla vuosikeskiarvona';

raha = 0;

%DO i = 1 %TO 12;
	%LLisaK1S(temp, &mvuosi, &i, &minf, &puoliso, &alle_3_v, &b16v, &jarj);
  	raha = SUM(raha, temp);
%END;

&tulos = raha / 12;
DROP raha temp;
%MEND LLisaV1S;


/* 10. Makro, jolla mritelln itiysavustukseen oikeuttavien lasten lukumr 
	   vuodesta 2003 lhtien. Korkeintaan neloset otetaan huomioon. */

* Makron parametrit:
	aitlkm: itiysavustukseen oikeuttavien lasten lukumr 
	luku: itiysavustuksien kappalemr;

%MACRO AitLkm(aitlkm, luku)/
DES = 'LLISA: Makro, jolla mritelln itiysavustukseen oikeuttavien lasten lukumr vuodesta 2003 lhtien';

SELECT (&luku);
	WHEN(0) temp = 0;
	WHEN(1) temp = 1;
	WHEN(3) temp = 2;
	WHEN(6) temp = 3;
	WHEN(10) temp = 4;
	OTHERWISE temp = 1;
END;

&aitlkm = temp;
DROP temp;
%MEND AitLkm;